/*
 * Entity Tyler 1998-1999.
 */ 

   import java.awt.*;
   import java.applet.*;

   public class Entity extends Object {
      final static int shift = 8;
   
      int x; // Image offScrImage;
      int y; // 
   
      int dx;
      int dy;
   
      int preserved_x;
      int preserved_y;
   
      int acceleration;
   
      char colour = 511;
   
      int status;
   
      byte direction;
      byte preferred_direction;
   
      int detection_radius;
   
      byte diameter = 18;
      byte radius = (byte)(diameter >>> 1);
   
      byte target_diameter;
   
      byte log_mass;
   
      int current_bin_x = -1;
      int current_bin_y = -1;
   
      ListOfLinks list_of_links;
      Creature creature;
   
      boolean i_am_a_leader; // ?
   
      // static...
      static Hortensius32Fast rnd = new Hortensius32Fast();
   
      static int max_velocity;
   
      static int friction_strength;
   
      static int temp_detection_distance;
      static int temp_detection_distance_squared;
   
      static Hortensius32Fast static_rnd = new Hortensius32Fast();
   
      static int new_bin_x;
      static int new_bin_y;
   
      static int temp, temp2, temp3, temp4, temp5, temp6;
      static int agent_counter;
      static int temp_direction;
      static int temp_count;
   
      static int tadx;
      static int tady;
      static int t2adx;
      static int t2ady;
   
      static int temp_x, temp_y;
      static int temp_radius, temp_diameter;
   
      static Entity temp_agent;
      static Entity temp2_agent;
   
      static int[] sin_tab;
      static int[] cos_tab;
   
      static int lut_shift = 8;
      static int lut_magnitude = 1 << lut_shift;
   
      static int TRIG_TAB_SIZE   = 32;
      static int TRIG_TAB_SIZEMO = TRIG_TAB_SIZE - 1;
      static int TRIG_TAB_SIZEO2 = TRIG_TAB_SIZE >>> 1;
   
      final static int DEAD            = 1 << 31;
      final static int EYE             = 1 << 30;
      final static int FOLLOW          = 1 << 29;
      final static int DRAG            = 1 << 28;
      final static int FEAR            = 1 << 27;
      final static int ALWAYS_CIRCULAR = 1 << 26;
      final static int ALWAYS_HOLLOW   = 1 << 25;
      final static int IMMUNE          = 1 << 24;
      final static int IMMORTAL        = 1 << 23;
      final static int INFECTIOUS      = 1 << 22;
      final static int DEADLY          = 1 << 21;
      final static int SPREADING_DEATH = 1 << 20;
      final static int SELECTED        = 1 << 19;
      final static int FROZEN          = 1 << 18;
      final static int HAS_INNER_WORLD = 1 << 17;
   
      final static int DEATH_MASK      = 255; // 0 - 7
   
      final static int INITIAL_DEATH_STAGE = 255; // a number not a mask.
      final static int NO_LONGER_LATENT = 192;
      final static int BREAK_LINKS_NOW = 96;
   
      static int number_of_ship;
   
      static int xoffset = 0;
      static int yoffset = 0;
   
      static int number_of_ships = TRIG_TAB_SIZE;
   
      static Ships ship;
   
      static Image ship_image_array[];
      static Image ring_image;
      static Graphics temp_graphics_handle;
   
      static byte direction_bias = 0;
   
      static PrivateWorld temp_private_world;
   
   
      Entity() {
         list_of_links = new ListOfLinks();
      }
   
   
      Entity(int ix, int iy, int seed) {
         x = ix;
         y = iy;
      
         rnd.setSeed(seed);
         dx = 0;
         dy = 0;
         status = 0;
      
         direction = 0;
         i_am_a_leader = false;
      
         acceleration = 4;
      
         list_of_links = new ListOfLinks();
      
         setInitialSize(EntityManager.general_size, EntityManager.general_size);
         log_mass = 16;
      }
   
   
      Entity(Entity e) {
         list_of_links = new ListOfLinks();
         set(e); //  No problem ;-)
      }
   
   
   
      void set(int ix, int iy, int seed) {
         x = ix;
         y = iy;
      
         rnd.setSeed(seed);
         dx = 0;
         dy = 0;
         status = 0;
      
         direction = 0;
         i_am_a_leader = false;
      
         acceleration = 4;
      
         list_of_links.reset();
      
         setInitialSize(EntityManager.general_size, EntityManager.general_size);
         log_mass = 16;
      }
   
   
      void set(Entity e) {
         x = e.x;
         y = e.y;
      
         dx = e.dx;
         dy = e.dy;
      
         colour = e.colour;
         i_am_a_leader = e.i_am_a_leader;
      
         acceleration = e.acceleration;
         status = e.status;
         creature = e.creature;
      
         target_diameter = e.target_diameter;
         diameter = e.diameter;
         radius = e.radius;
         detection_radius = e.detection_radius;
      
         log_mass = e.log_mass;
      
         current_bin_x = e.current_bin_x;
         current_bin_y = e.current_bin_y;
      
         preserved_x = e.preserved_x;
         preserved_y = e.preserved_y;
      
         direction = e.direction;
         preferred_direction = e.preferred_direction;
      
         list_of_links.reset(); // no links yet, though...
      }
   
   
   	// need "reset entity" routines here...
      final public static void initial() {
         sin_tab = new int[TRIG_TAB_SIZE];
         cos_tab = new int[TRIG_TAB_SIZE];
         for (temp = 0; temp < TRIG_TAB_SIZE; temp++) {
            sin_tab[temp] = (int)(lut_magnitude * (java.lang.Math.sin((temp * 2 * java.lang.Math.PI) / (double)TRIG_TAB_SIZE)) + 0.5);
            cos_tab[temp] = (int)(lut_magnitude * (java.lang.Math.cos((temp * 2 * java.lang.Math.PI) / (double)TRIG_TAB_SIZE)) + 0.5);
         }
      
         ship_image_array = new Image[number_of_ships];
      }
   
   
      public void makeShips(int ship_size, int n) {
         ship        = new Ships();
         ship.aa_col = 0x002020;
         ship.pixel  = 0.5;
         ship.shadow = 0.5;
         ship.ship_type = 3;
         ship.rnd.setSeed(1);
         ship.generateShip(diameter, direction);
      
         ship_image_array[number_of_ship] = ship.ship_white;
      }
   
   
      protected void drawShip() {
         temp_radius = diameter; // drawn_ship_size;
      
         number_of_ship = direction;
      
         // System.out.println("11");
      
         if (ship_image_array[number_of_ship] == null)
            makeShips(diameter,number_of_ship);
      
         // System.out.println("12");
      
         if (Shoals_Canvas.observer != null) {
            if (Shoals_Grid.graphics_handle != null) {
               Shoals_Grid.graphics_handle.drawImage(ship_image_array[number_of_ship], temp_x, temp_y, temp_radius, temp_radius, Shoals_Canvas.observer);
            }
         }
      }
   
   
      public void draw() {
         if (colour != 0) {
            preserved_x = ((x) >>> shift);
            preserved_y = ((y) >>> shift);
            // pdiameterer = diameter;
         
            temp_x = preserved_x - radius;
            temp_y = preserved_y - radius;
            temp = radius + 2;
         
            temp2 = Shoals.quality;
            if ((status & (ALWAYS_CIRCULAR | ALWAYS_HOLLOW)) != 0) {
               if ((status & ALWAYS_CIRCULAR) != 0) {
                  switch (temp2) {
                     case Shoals._QUALITY_3:
                        temp2 = Shoals._QUALITY_2;
                        break;
                     case Shoals._QUALITY_4:
                        temp2 = Shoals._QUALITY_1;
                        break;
                  }
               }
               if ((status & ALWAYS_HOLLOW) != 0) {
                  switch (temp2) {
                     case Shoals._QUALITY_4:
                        temp2 = Shoals._QUALITY_3;
                        break;
                     case Shoals._QUALITY_4A:
                        temp2 = Shoals._QUALITY_3A;
                        break;
                     case Shoals._QUALITY_1:
                        temp2 = Shoals._QUALITY_2;
                        break;
                     case Shoals._QUALITY_1A:
                        temp2 = Shoals._QUALITY_2A;
                        break;
                  }
               }
            }
         
            switch (temp2) {
               case Shoals._QUALITY_0:
                  drawShip();
               
                  break;
            
               case Shoals._QUALITY_1:
               case Shoals._QUALITY_1A:
                  if (Shoals_Grid.last_colour != colour) {
                     Shoals_Grid.colour = colour;
                     Shoals_Grid.quicklySetUpColour();
                  }
               
                  Shoals_Grid.graphics_handle.fillOval(temp_x, temp_y, diameter, diameter);
               
                  if ((status & EYE) != 0) {
                     fillPupil();
                  }
               
                  break;
            
               case Shoals._QUALITY_2:
               case Shoals._QUALITY_2A:
                  if (Shoals_Grid.last_colour != colour) {
                     Shoals_Grid.colour = colour;
                     Shoals_Grid.quicklySetUpColour();
                  }
               
                  Shoals_Grid.graphics_handle.drawOval(temp_x, temp_y, diameter, diameter);
               
                  if ((status & EYE) != 0) {
                     drawPupil();
                  }
               
                 // if ((!Shoals.gas_sim) && (!Shoals.chained)) {
                     //Shoals_Grid.graphics_handle.drawRect(preserved_x - 1 + ((cos_tab[direction] * temp) >> lut_shift), preserved_y - 1 - ((sin_tab[direction] * temp) >> lut_shift), 2, 2);
                  //}
               
                  break;
            
               case Shoals._QUALITY_3A:
                  if (Shoals_Grid.last_colour != colour) {
                     Shoals_Grid.colour = colour;
                     Shoals_Grid.quicklySetUpColour();
                  }
               
                  Shoals_Grid.graphics_handle.drawRect(preserved_x - (radius >> 1), preserved_y - (radius >> 1), radius, radius);
               
                  break;
            
               case Shoals._QUALITY_3:
                  if (Shoals_Grid.last_colour != colour) {
                     Shoals_Grid.colour = colour;
                     Shoals_Grid.quicklySetUpColour();
                  }
               
                  //
                  if ((status & ALWAYS_CIRCULAR) != 0) {
                     Shoals_Grid.graphics_handle.drawOval(temp_x, temp_y, diameter, diameter);
                     if ((status & EYE) != 0) {
                        drawPupil();
                     }
                  }
                  else
                  {
                     Shoals_Grid.graphics_handle.drawRect(preserved_x - (radius >> 1), preserved_y - (radius >> 1), radius, radius);
                  }
               
                  break;
            
               case Shoals._QUALITY_4A:
                  if (Shoals_Grid.last_colour != colour) {
                     Shoals_Grid.colour = colour;
                     Shoals_Grid.quicklySetUpColour();
                  }
               
                  Shoals_Grid.graphics_handle.fillRect(preserved_x - (radius >> 1), preserved_y - (radius >> 1), radius, radius);
               
                  break;
            
               case Shoals._QUALITY_4:
                  if (Shoals_Grid.last_colour != colour) {
                     Shoals_Grid.colour = colour;
                     Shoals_Grid.quicklySetUpColour();
                  }
               
                  if ((status & ALWAYS_CIRCULAR) != 0) {
                     Shoals_Grid.graphics_handle.fillOval(temp_x, temp_y, diameter, diameter);
                     if ((status & EYE) != 0) {
                        fillPupil();
                     }
                  }
                  else
                  {
                     Shoals_Grid.graphics_handle.fillRect(preserved_x - (radius >> 1), preserved_y - (radius >> 1), radius, radius);
                  }
               
                  break;
            
            }
         }
      
         if ((status & SELECTED) != 0) {
            Shoals_Grid.colourRed();
            Shoals_Grid.graphics_handle.drawOval(temp_x - 8, temp_y - 8, diameter + 16, diameter + 16);
         }
      }
   
   
   // colour set up?
      public void scrub() {
         if (colour != 0) {
         //preserved_x = ((x * Shoals_Grid.gridsize) >>> shift);
         //preserved_y = ((y * Shoals_Grid.gridsize) >>> shift);
         
         // Shoals_Grid.graphics_handle.fillRect(preserved_x - radius,preserved_y - radius,diameter,diameter);
            // temp = diameter >> 1;
            temp_x = preserved_x - radius;
            temp_y = preserved_y - radius; // (temp);
         
            temp2 = Shoals.quality;
            if ((status & (ALWAYS_CIRCULAR | ALWAYS_HOLLOW)) != 0) {
               if ((status & ALWAYS_CIRCULAR) != 0) {
                  switch (temp2) {
                     //case Shoals._QUALITY_3A:
                        //temp2 = Shoals._QUALITY_2A;
                        //break;
                  
                     case Shoals._QUALITY_3:
                        temp2 = Shoals._QUALITY_2;
                        break;
                  
                     //case Shoals._QUALITY_4A:
                        //temp2 = Shoals._QUALITY_1A;
                        //break;
                  
                     case Shoals._QUALITY_4:
                        temp2 = Shoals._QUALITY_1;
                        break;
                  }
               }
               if ((status & ALWAYS_HOLLOW) != 0) {
                  switch (temp2) {
                     case Shoals._QUALITY_4:
                        temp2 = Shoals._QUALITY_3;
                        break;
                     case Shoals._QUALITY_4A:
                        temp2 = Shoals._QUALITY_3A;
                        break;
                     case Shoals._QUALITY_1:
                        temp2 = Shoals._QUALITY_2;
                        break;
                     case Shoals._QUALITY_1A:
                        temp2 = Shoals._QUALITY_2A;
                        break;
                  }
               }
            }
         
            switch (temp2) {
               case Shoals._QUALITY_0:
               case Shoals._QUALITY_1A:
                  Shoals_Grid.graphics_handle.clearRect(temp_x, temp_y, diameter, diameter);
               
                  break;
            
               case Shoals._QUALITY_2A:
                  Shoals_Grid.graphics_handle.clearRect(temp_x, temp_y, diameter + 1, diameter + 1);
               
                  break;
            
               case Shoals._QUALITY_1:
                  Shoals_Grid.colourZero();
                  Shoals_Grid.graphics_handle.fillOval(temp_x, temp_y, diameter, diameter);
                  break;
            
               case Shoals._QUALITY_2:
                  if ((status & EYE) != 0) {
                     Shoals_Grid.colourZero();
                     Shoals_Grid.graphics_handle.drawOval(temp_x, temp_y, diameter, diameter);
                     drawPupil();
                  // TEMPORARY FUDGE!!!!
                     //Shoals_Grid.graphics_handle.fillOval(temp_x, temp_y, diameter, diameter);
                  }
                  else
                  {
                     Shoals_Grid.colourZero();
                     Shoals_Grid.graphics_handle.drawOval(temp_x, temp_y, diameter, diameter);
                  }
               
                  break;
            
               case Shoals._QUALITY_3A:
                  Shoals_Grid.graphics_handle.clearRect(preserved_x - (radius >> 1), preserved_y - (radius >> 1), radius + 1, radius + 1);
               
                  break;
            
               case Shoals._QUALITY_3:
                  if ((status & ALWAYS_CIRCULAR) != 0) {
                     Shoals_Grid.colourZero();
                     Shoals_Grid.graphics_handle.drawOval(temp_x, temp_y, diameter, diameter);
                     if ((status & EYE) != 0) {
                        drawPupil();
                     }
                  }
                  else
                  {
                     Shoals_Grid.graphics_handle.clearRect(preserved_x - (radius >> 1), preserved_y - (radius >> 1), radius + 1, radius + 1);
                  }
               
                  break;
            
            
               case Shoals._QUALITY_4A:
                  Shoals_Grid.graphics_handle.clearRect(preserved_x - (radius >> 1), preserved_y - (radius >> 1), radius, radius);
               
                  break;
            
               case Shoals._QUALITY_4:
                  if ((status & ALWAYS_CIRCULAR) != 0) {
                     Shoals_Grid.graphics_handle.clearRect(preserved_x - radius, preserved_y - radius, diameter, diameter);
                  }
                  else
                  {
                     Shoals_Grid.graphics_handle.clearRect(preserved_x - (radius >> 1), preserved_y - (radius >> 1), radius, radius);
                  }
               
                  // Shoals_Grid.graphics_handle.clearRect(preserved_x - (radius >> 1), preserved_y - (radius >> 1), radius, radius);
               
                  break;
            
            }
         }
      
         if ((status & SELECTED) != 0) {
            Shoals_Grid.colourZero();
            Shoals_Grid.graphics_handle.drawOval(temp_x - 8, temp_y - 8, diameter + 16, diameter + 16);
         }
      }
   
   
      public boolean isSelected() {
      
         return ((status & SELECTED) != 0);
      }
   
   
      public void drawPupil() {
         temp2 = radius >> 1;
         Shoals_Grid.graphics_handle.drawOval(preserved_x - temp2 + ((cos_tab[direction] * temp2) >> lut_shift), preserved_y - temp2 + ((sin_tab[direction] * temp2) >> lut_shift), radius, radius);
      }
   
   
      public void fillPupil() {
         Shoals_Grid.colour = 0;
         Shoals_Grid.setUpColour();
      
         temp2 = radius >> 1;
         Shoals_Grid.graphics_handle.fillOval(preserved_x - temp2 + ((cos_tab[direction] * temp2) >> lut_shift), preserved_y - temp2 + ((sin_tab[direction] * temp2) >> lut_shift), radius, radius);
      }
   
   
      public void setMass(byte lm) {
         log_mass = lm;
      }
   
   
      public void setSize(byte d) {
         diameter = d;
         radius = (byte)(diameter >>> 1);
         detection_radius = (byte)(radius + 1);
      }
   
   
      public void setCurrentSize(byte d) {
         diameter = d; 
         radius = (byte)(diameter >>> 1);
         detection_radius = (byte)(radius + 1);
      }
   
   
      public void setInitialSize(byte i, byte d) {
         target_diameter = d;
         setCurrentSize(i);
      }
   
   
      public void travel() {
         temp = static_rnd.nextInt();
      
         capVelocities();
      
         if ((status & FROZEN) == 0) {
            x = x + dx;
            y = y + dy;
         }
      
         applyFriction();
      
         boundaryCheck();
      
         adjustDirection();
      
         adjustCellSize();
      
         if ((status & DEATH_MASK) != 0) {
            status--;
         
            colour = (char)(((status & 8) == 0) ? ((status & 7) + 1) : ((rnd.nextInt() >>> 23) | 1));
         
            if ((status & DEATH_MASK) == 0) {
               if ((status & HAS_INNER_WORLD) != 0) {
                  PrivateWorldManager.copyEverythingOut(this, temp_private_world);
               }
            
               explode();
            
               temp_private_world.link_manager.killAllLinks(this); // done 4 us
            
               temp_private_world.killThisEntity(this);  // dangerous stuff...
            }
         }
      }
   
   
      public void explode() {
         if (Shoals.show_exhaust) {
            for (temp = 0; temp < (TRIG_TAB_SIZE); temp++) {
               temp3 = rnd.nextInt();
               temp_radius = 0x100 + (temp3 & 0xff);
               temp_x = temp3 >> 24;
               temp_y = (temp3 << 8) >> 24;
            
               ParticleManager.add(x - cos_tab[temp] * radius, y - sin_tab[temp] * radius,
                                  dx - ((cos_tab[temp] * temp_radius) >> (lut_shift)) + temp_x,
                                  dy - ((sin_tab[temp] * temp_radius) >> (lut_shift)) + temp_y,
                                  Particle.POINT);
                     //temp++;
               temp_radius = 0x100 + ((temp3 >> 8) & 0xff);
               temp_x = (temp3 << 22) >> 24;
               temp_y = (temp3 << 18) >> 24;
            
               ParticleManager.add(x - cos_tab[temp] * radius, y - sin_tab[temp] * radius,
                                  dx - ((cos_tab[temp] * temp_radius) >> (lut_shift)) + temp_x,
                                  dy - ((sin_tab[temp] * temp_radius) >> (lut_shift)) + temp_y,
                                  Particle.POINT);
            
               temp++;
               temp_radius = 0x100 + ((temp3 >> 10) & 0xff);
               temp_x = (temp3 << 12) >> 24;
               temp_y = (temp3 << 4) >> 24;
            
               ParticleManager.add(x - cos_tab[temp] * radius, y - sin_tab[temp] * radius,
                                  dx - ((cos_tab[temp] * temp_radius) >> (lut_shift)) + temp_x,
                                  dy - ((sin_tab[temp] * temp_radius) >> (lut_shift)) + temp_y,
                                  Particle.CROSS);
                     //temp++;
               temp_radius = 0x100 + ((temp3 >> 12) & 0xff);
               temp_x = (temp3 << 16) >> 24;
               temp_y = (temp3 << 20) >> 24;
            
               ParticleManager.add(x - cos_tab[temp] * radius, y - sin_tab[temp] * radius,
                                  dx - ((cos_tab[temp] * temp_radius) >> (lut_shift)) + temp_x,
                                  dy - ((sin_tab[temp] * temp_radius) >> (lut_shift)) + temp_y,
                                  Particle.BLOB);
            
            
            }
         
                  //for (temp2 = 0; temp2 < 1; temp2++) {
            temp5 = (40 / diameter) + 1;
         
            for (temp = 0; temp <= (TRIG_TAB_SIZE - temp5); temp = temp + temp5) {
               temp4 = (temp + temp5) & TRIG_TAB_SIZEMO;
               temp3 = rnd.nextInt();
               temp_radius = (temp3 & 0x1ff);
               temp_x = 0;
               temp_y = 0;
            
               LineFragmentManager.add(x - cos_tab[temp] * radius, y - sin_tab[temp] * radius,
                                    x - cos_tab[temp4] * radius, y - sin_tab[temp4] * radius,
                                    dx - ((cos_tab[temp] * temp_radius) >> (lut_shift)) + temp_x,
                                    dy - ((sin_tab[temp] * temp_radius) >> (lut_shift)) + temp_y, 1024);
            }
         }
      }
   
   
      public boolean isAlive() {
         return ((status & DEAD) == 0);
      }
   
   
      public void thrust(int t) {
         if ((status & FOLLOW) != 0) {
            temp_direction = (direction - preferred_direction) & TRIG_TAB_SIZEMO;
            if ((temp_direction < 8) || (temp_direction > (TRIG_TAB_SIZEMO - 7))) {
            // thrusting
               dx += (cos_tab[direction] * t) >> (8 + lut_shift);
               dy += (sin_tab[direction] * t) >> (8 + lut_shift);
            /*
               if (booked_for_speeding < 2) {
                  if ((booked_for_speeding == 0) || ((Shoals_Grid.generation & 3) == 0)) {
                     if (Shoals.show_exhaust) {
                        temp_y = x ^ y ^ Shoals_Grid.generation;
                        temp_radius = 0x60000 + ((temp_y & 15) << 16);
                        temp_x = 128 - ((temp_y & 15) << 4);
                        temp_y = 128 - ((temp_y & 15) << 4);
                     
                        Shoals_Grid.particle_manager.add(x, y,
                                             dx - ((cos_tab[direction] * temp_radius) >> (8 + lut_shift)) + temp_x, // - 256 + (x & 511),
                                             dy - ((sin_tab[direction] * temp_radius) >> (8 + lut_shift)) + temp_y); //  - 256 + (y & 511));
                     }
                  }
               }
            	*/
            
            }
         }
      
      // fear some...
         if ((status & FEAR) != 0) {
            temp_direction = (direction - preferred_direction) & TRIG_TAB_SIZEMO;
            if ((temp_direction < 8) || (temp_direction > (TRIG_TAB_SIZEMO - 7))) {
            // thrusting
               dx -= (cos_tab[direction] * t) >> (8 + lut_shift);
               dy -= (sin_tab[direction] * t) >> (8 + lut_shift);
            }
         }
      }
   
   
      public void adjustDirection() {
         if (((x + y) & 3) == 0) {
            temp = (direction - preferred_direction) & TRIG_TAB_SIZEMO;
            if (temp > TRIG_TAB_SIZEO2) {
               direction = (byte)((direction + 1) & TRIG_TAB_SIZEMO);
            }
            else
            {
               if (temp < TRIG_TAB_SIZEO2) {
                  direction = (byte)((direction - 1) & TRIG_TAB_SIZEMO);
               }
            }
         }
      }
   
   
      public void capVelocities() {
         // booked_for_speeding = 0;
      
         // cap velocities...
         if ((dx > max_velocity) || (dx < -max_velocity) || (dy > max_velocity) || (dy < -max_velocity)) {
            if (max_velocity == 0) {
               dx = 0;
               dy = 0;
            }
            else
            {
               if (dx > (max_velocity << 2))
                  dx = max_velocity << 2;
               if (dx < -(max_velocity << 2))
                  dx = -(max_velocity << 2);
               if (dy > (max_velocity << 2))
                  dy = max_velocity << 2;
               if (dy < -(max_velocity << 2))
                  dy = -(max_velocity << 2);
            
               //temp = 3;
               while (((dx * dx) + (dy * dy)) > (((max_velocity) * (max_velocity)) << 1)) {
               //while ((((dx * dx) + (dy * dy)) > (((max_velocity) * (max_velocity)) << 1)) && (temp-- > 0)) {
                  dx = dx >> 1;
                  dy = dy >> 1;
                  // booked_for_speeding++;
               }
            }
         }
      }
   
   
      public void boundaryCheck() {
      		// AMAZING!!!
         //debug("T:" + detection_radius);
         //temp = ((int)detection_radius); // severe bugs...!
         //debug("T2:" + temp);
      
         // temp = 0;
      
         //if (temp < 0) {
            //debug("T:" + temp);
         //}
      
         if (Shoals.boundaries) {
            if (((x >> shift) + ((int)detection_radius)) > Shoals_Canvas.gsx) {
            // if (((x >> shift) + 32) > Shoals_Canvas.gsx) {
               x = (Shoals_Canvas.gsx - ((int)detection_radius)) << shift; //x - dx;
               // x = (Shoals_Canvas.gsx - 32) << shift; //x - dx;
               if (dx > 0) {
                  dx = -(int)(dx * 0.95);
               }
            }
         
         
            if ((x >> shift) < ((int)detection_radius)) {
               x = ((int)detection_radius) << shift;
               if (dx < 0) {
                  dx = -(int)(dx * 0.95);
               }
            }
         
            temp = (Shoals_Canvas.gsy * (EntityManager.piston + 24)) >>> 10; // CALC ONCE ONLY!
            if (((y >> shift) + ((int)detection_radius)) > temp) {
               y = (temp - (int)detection_radius) << shift;
               if (dy > 0) {
                  dy = -(int)(dy * 0.95);
               }
            }
         
            if ((y >> shift) < ((int)detection_radius)) {
               y = ((int)detection_radius) << shift;
               if (dy < 0) {
                  dy = -(int)(dy * 0.95);
               }
            }
         }
      }
   
   
      public void adjustCellSize() {
         if ((Shoals_Grid.generation & 63) == 11) {
            if (diameter < target_diameter) {
               if ((target_diameter - diameter) >= 16) {
                  temp = (target_diameter - diameter) >> 3;
               }
               else
               {
                  temp = 1;
               }
            
               setCurrentSize((byte)(diameter + temp));
            }
            else
            {
               if (diameter > target_diameter) {
                  if ((diameter - target_diameter) >= 16) {
                     temp = (diameter - target_diameter) >> 3;
                  }
                  else
                  {
                     temp = 1;
                  }
                  setCurrentSize((byte)(diameter - temp));
               }
            }
         }
      }
   
   
      public void applyFriction() {
      // cap velocities...
         // if (((x + y) & 7) == 0) {
         if ((status & DRAG) != 0) {
            if (friction_strength > 0) {
               dx = (dx * (512 - friction_strength)) >> 9;
               dy = (dy * (512 - friction_strength)) >> 9;
            
            }
         /*
            if (dx > 0) {
               dx -= friction_strength;
               if (dx < 0) {
                  dx = 0;
               }
            }
         
            if (dx < 0) {
               dx += friction_strength;
               if (dx > 0) {
                  dx = 0;
               }
            }
         
            if (dy > 0) {
               dy -= friction_strength;
               if (dy < 0) {
                  dy = 0;
               }
            }
         
            if (dy < 0) {
               dy += friction_strength;
               if (dy > 0) {
                  dy = 0;
               }
            }
         	*/
         }
      }
   
   
      final public void findNewBin() {
         if (!Shoals.oscd) {
            new_bin_x = x >>> EntityGrid.log2binsize;
            new_bin_y = y >>> EntityGrid.log2binsize;
         
            if ((current_bin_x != new_bin_x) || (current_bin_y != new_bin_y)) {
               EntityGrid.addToList(new_bin_x, new_bin_y, this);
               EntityGrid.removeFromList(current_bin_x, current_bin_y, this);
            
               current_bin_x = new_bin_x;
               current_bin_y = new_bin_y;
            }
         }
      }
   
   
      final public void removeFromBin() {
         if (!Shoals.oscd) {
            EntityGrid.removeFromList(current_bin_x, current_bin_y, this);
         }
      }
   
   
      final void addLink(Link l) {
         list_of_links.add(l);
      }
   
   
      // kills entity e1...
      final static void simplyKill(Entity e1) {
         e1.status = (e1.status & (-1 ^ FOLLOW ^ FEAR ^ INITIAL_DEATH_STAGE)) | (SPREADING_DEATH | DRAG | (INITIAL_DEATH_STAGE - rnd.nextInt(32)));
      }
   
   
   	// kills entity e1...
      final void simplyKill() {
         status = (status & (-1 ^ FOLLOW ^ FEAR ^ INITIAL_DEATH_STAGE)) | (SPREADING_DEATH | DRAG | (INITIAL_DEATH_STAGE - rnd.nextInt(32)));
      }
   
   
      final void simplyKillAsSlowlyAsPossible() {
         status = (status & (-1 ^ FOLLOW ^ FEAR ^ INITIAL_DEATH_STAGE)) | (SPREADING_DEATH | DRAG | (INITIAL_DEATH_STAGE));
      }
   
   
      final void killLikeEgg() {
         status = (status & (-1 ^ FOLLOW ^ FEAR ^ INITIAL_DEATH_STAGE)) | (INITIAL_DEATH_STAGE);
      }
   
   
      // infects entity E1 with Entity e2...
      final static void infectByContact(Entity e1, Entity e2) {
         e1.status = (e1.status & (-1 ^ FOLLOW ^ FEAR ^ INITIAL_DEATH_STAGE)) | (SPREADING_DEATH | DRAG | (INITIAL_DEATH_STAGE - rnd.nextInt(32)));
      
         if ((e2.status & INFECTIOUS) != 0) {
            e1.status |= (e2.status & (DEADLY | INFECTIOUS));
         }
      }
   
   
   	// infects entity E1 with Entity e2...
      final static void infectAlongALink(Entity e1, Entity e2) {
         e1.status = (e1.status & (-1 ^ FOLLOW ^ FEAR ^ INITIAL_DEATH_STAGE)) | (SPREADING_DEATH | DRAG | (INITIAL_DEATH_STAGE - rnd.nextInt(32)) | (e2.status & (DEADLY | INFECTIOUS)));
      }
   
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
