/*
 * PairManager Tyler 1998-2000.
 */

   public class PairManager extends Object {
      Pair[] entity_pair;
      Pair[] new_array_of_pairs;
   
      int max_number_of_pairs = 1;
      int number_of_pairs;
   
      // static stuff...
      static int agent_counter;
      static int shift = Entity.shift;
   
      static int temp, temp2, temp3, temp4, temp5, temp6;
      static Pair temp_pair;
   
      static Entity temp_entity;
      static int threshold = 8;
      static int bigthreshold = threshold << Entity.shift;
   
      static int temp_x, temp_y, temp_radius;
   
      static int PAIR_NUMBER_INCREMENT = 16;
   
   
      PairManager() {
         entity_pair = new Pair[max_number_of_pairs];
      
         reset();
      }
   
   
      void reset() {
         number_of_pairs = 0;
      }
   
   
   
      final Pair add(Entity e1, Entity e2) {
         if (number_of_pairs >= max_number_of_pairs) {
            makeMorePairs();
         }
      
         if (entity_pair[number_of_pairs] == null) {
            temp_pair = new Pair(e1, e2);
            entity_pair[number_of_pairs++] = temp_pair;
         }
         else
         {
            temp_pair = entity_pair[number_of_pairs++];
            temp_pair.set(e1, e2);
         }
      
         return temp_pair;
      }
   
   
   
   
   // DANGER
      final void add(Pair l) {
         if (number_of_pairs >= max_number_of_pairs) {
            makeMorePairs();
         }
      
         // entity_pair[number_of_pairs++] = l; /// eeekkkk!
         entity_pair[number_of_pairs++].set(l); /// eeekkkk!
      }
   
   
      final void makeMorePairs() {
         new_array_of_pairs = new Pair[max_number_of_pairs + PAIR_NUMBER_INCREMENT];
      
         for (temp = max_number_of_pairs; --temp >= 0; ) {
            new_array_of_pairs[temp] = entity_pair[temp];
         }
      
         entity_pair = new_array_of_pairs;
      
         max_number_of_pairs += PAIR_NUMBER_INCREMENT;
      }
   
   
      final boolean aPairLikeThisExists(Entity e1, Entity e2) {
         for (temp = number_of_pairs; --temp >= 0; ) {
            if ((entity_pair[temp].entity1 == e1) && (entity_pair[temp].entity2 == e2)) {
               return true;
            }
         
            if ((entity_pair[temp].entity1 == e2) && (entity_pair[temp].entity2 == e1)) {
               return true;
            }
         }
      
         return false;
      }
   
   
   // need to re-write this so that it uses local list of Pairs stored with entity...

   // doesn't quite work properly...
      final void deleteAllPairsBetween(Entity e1, Entity e2) {
         for (temp = number_of_pairs; --temp >= 0; ) {
            if ((entity_pair[temp].entity1 == e1) && (entity_pair[temp].entity2 == e2)) {
               killNumberedPair(temp);
            }
         
            if ((entity_pair[temp].entity1 == e2) && (entity_pair[temp].entity2 == e1)) {
               killNumberedPair(temp);
            }
         }
      }
   
   
   // ?.
      final boolean thereIsAPair(Entity e1, Entity e2) {
         for (temp = number_of_pairs; --temp >= 0; ) {
            if ((entity_pair[temp].entity1 == e1) && (entity_pair[temp].entity2 == e2)) {
               return true;
            }
         }
      
         return false;
      }
   
      final Entity findCorrespondingEntity(Entity e) {
         for (temp = number_of_pairs; --temp >= 0; ) {
            if ((entity_pair[temp].entity1 == e)) {
               return entity_pair[temp].entity2;
            }
         }
      
         return null;
      }
   
   
      // hmm...
      final void killAllPairs(Entity e) {
         for (temp = number_of_pairs; --temp >= 0; ) {
            if ((entity_pair[temp].entity1 == e) || (entity_pair[temp].entity2 == e)) {
               killNumberedPair(temp);
            }
         }
      }
   
   
      // hmm...
      final boolean killLastPair(Entity e) {
         for (temp = number_of_pairs; --temp >= 0; ) {
            if ((entity_pair[temp].entity1 == e) || (entity_pair[temp].entity2 == e)) {
               killNumberedPair(temp);
               return true;
            }
         }
      
         return false;
      }
   
   
      final void killNumberedPair(int n) {
         temp_pair = entity_pair[n];
      
         // need to tell the entities involved...
         temp_pair.entity1 = null;
         temp_pair.entity2 = null;
         entity_pair[n] = entity_pair[number_of_pairs - 1];
         entity_pair[--number_of_pairs] = temp_pair;
      }
   
   
      final int getNumberOfPair(Pair l) {
         for (temp = number_of_pairs; --temp >= 0; ) {
            if (entity_pair[temp] == l) {
               return temp;
            } 
         }
      
         return -1; // not found...
      }
   
   
      final void killSpecifiedPair(Pair l) {
         temp = getNumberOfPair(l);
         killNumberedPair(temp);
      }
   
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
