 /*
  * Shoals - Tim Tyler 2000-2000
  */

 /* To do
  * =====
  *
  * Bins when paused...?
  * Reproduction by a gradual process of node splitting and link creation...
  * * Less bud, more equality...?
  * * Sort budding links *properly*...
  * * A few NPE BUGS...???
  * Graphical egg breakdown...
  * Graphical solid sphere explosion...
  * Rhythmic motion...
  * Muscles...
  * Feet...
  * Add a class of rectangular objects...
  * Allow variable TLHC co-ordinates...
  * Sophisticated solid background with intelligent redraw...
  * Consider "very large" number of bins...
  * "Sticky" cells - form links (with other sticky cells?) on contact...?
  * "Ignore collisions with self" - i.e. cells of the same creature - flag...
  * Preferred (reading clockwise) order of links from a cell!? ;-)
  * (Eventually) all forces (e.g. spring force) need to pay attention to mass...
  * Sort out bugs in collision detection when "off screen"...
  * Drag box around items to create multiple selected items...
  * Explosions blow away nearby objects, also causing damage...
  * Replace lower panel if selection exists...
  * Design more creatures...
  * "Source" objects...
  * "Sink" objects...
  * Keyboard navigation - e.g. pressing DELETE deletes the currect selection...
  * 3D - (/perhaps/ using Java3D...?)
  * Objective C???
  * Allow target eggs to be selected...?
  * Add mass - and conservation of energy - to the physics of the collisions... 
  * Links display: AA circles...?
  * Allow joints to have preferred angles...?
  * Swimming motion - and resistance to water...
  * Write associated game...
  * Consider networking options...
  * Branch codebase to allow self-reproducing crystals...
  * Branch codebase to allow self-reproducing amphilic membranes...
  * Fix "panel off" switch...
  * Anti-aliased line drawing library (DIY using sphere plotting!?) (DIY using blur??)...
  * Every creature has a PW field - which it does not need?
  * 
  * Done
  * ====
  *
  * * Final clean-up could be smoother...
  * * Proper new creature bugs...
  * * Sort links into correct order...
  * One creature manager per world...?
  * Optionally attach the egg to the parent/Optionally give birth to live young...
  * Remove LHS control...
  * Attach the egg to the parent during development (*should* be easy)...
  * Preferred number of creatures control...
  * Bigger eggs? / Smooth egg growth...
  * Self-reproduction...
  * Diseased objects...
  * UI support for IMMUNE and IMMORTAL...
  * Bigger eggs?
  * Reproduction by growth inside an egg!
  * Don't reproduce if you're inside an egg...
  * Worlds within worlds...
  * Flag to say that a cell has an inner world...
  * UI support for IMMUNE and IMMORTAL...
  * Links break when a critical length is reached...
  * Kill creature as soon as it is touched by death... (BUGS, though)
  * Fatal objects...
  * Immortality...
  * Immunity...
  * back end support for ALWAYS_CIRCULAR, ALWAYS_HOLLOW
  * INFINITE_INFECTION...
  * Add mass to the physics of the collisions... 
  * Long links grow more rapidly...
  * Growth after reproduction...
  * Kill creature as soon as it is touched by death...
  * Illness clears follow/fear...
  * Collision with self is treated differently to collision with other... ;-)
  * Make note of which cells belong to which creatures...
  * Reproduction by duplication at a small size, followed by growth...
  * Dragging a node drags all selected nodes...!
  * Checkboxes for eye/drag/follow/etc...
  * Modifications (E, SIZ) affect multiple selected items...
  * Buttons for DELETE etc...
  * Explosions of links work from link length...
  * Sophisticated explosions of joined lines segments...
  * Make links explode properly...
  * Line fragment contructor based on (x1, y1) and (x2,y2)...
  * Explosions of lines (simple and easy)...
  * CTRL-Click toggles selection...
  * Select/move...
  * Modifications of link elasticity/length...
  * Link creation problems...
  * Add slider for minimum energy in collisions...
  * Improved physics in the collisions
  * Selection not /always/ instantaneous?
  * Allow for multiple selections with the "control" key...
  * Allow selection and modifications of links...
  * Allow copy/paste of selected atoms...
  * Allow selection of atoms...
  * Checkboxes for long/short links...
  * Bleach links... 
  * Repeated link? Replace it!
  * Link to self?  Kill!
  * Unresponsive UI bug...
  * Explosive deaths...
  * Slow, "transmitted" death...
  * Web site...
  * Repulsion...
  * Only particular cells are attracted...
  * UI for initial configurations (EASY)...
  * Allow scale and position of creatures to be modified (EASY)...
  * Save status...
  * Initial configurations (EASY)...
  * Quick/condensed save (EASY)...
  * Special display for "eyes"...
  * Alternate display options for the links: lines/dots/truncated lines/AA circles (EASY)...
  * Colour editing facilities with +/-, number entry and copy/paste (EASY)...
  * Add objects with a fixed velocity of zero...
  * L + R mouse button choices...
  * Track down the bug that makes particles go "mad" after many deletions...?
  * Coloured agents...
  * Invisible lines...
  * Invisible nodes... ;-)
  * Faster collision detection: 2 diamonds? squares? ;-)
  * Dump state as text file...
  * Load state from text file...
  * Drag new connections...
  * "Starfish" - rods between cells...
  * Add "following" code back in...  
  * Add "panel off" switch...
  * Update "N" in the GUI...
  * Variable size egg...
  * Move individual atoms...
  * Crystallization model...
  * Click to kill...
  * Swarm behaviour, using grids...
  * Piston
  * Collisions...
  * Thrust points...
  * Variable-size creatures...
  * "Fast" display mode...
  * 
  */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.io.*;
   import java.lang.Exception;
   import java.lang.Integer;
   import java.lang.Long;
   import java.lang.Object;
   import java.util.StringTokenizer;
   import java.util.Date;
   import java.awt.image.*;
   import java.net.URL;
   import java.net.URLConnection;

   public class Shoals extends java.applet.Applet implements ActionListener, AdjustmentListener, ItemListener, Runnable {
      static boolean testing             = true;
      static boolean chained             = true;
      static boolean controls_visible    = true;
      static boolean output_linefeeds    = true;
      static boolean use_links           = true;
      static boolean boundaries          = true;
      static boolean oscd                = false;
      static boolean gas_sim             = false;
      static boolean development_version = false;
   
      static boolean currently_dragging = false;
   
      static int sample_rate = 64;
      static int use_native = 0;
   
      static TTMessage[] msgq;
      static Writer out;
   
      static TTChoice choose_resolution;
      static TTChoice choose_display;
      static TTChoice choose_kill;
      static TTChoice choose_start;
      static TTChoice choose_frequency;
      static TTChoice choose_mutation;
      static TTChoice choose_radiation;
      static TTChoice choose_delay;
      static TTChoice choose_sample_rate;
      static TTChoice choose_sample_number;
      static TTChoice choose_density;
      static TTChoice choose_quality;
      static TTChoice choose_tool;
      static TTChoice choose_initial;
      static TTChoice choose_left_action;
      static TTChoice choose_right_action;
      static TTChoice choose_link_display;
   
      static int threadfinished;
      static int threadnowfinished;
   
      static int current_message = 0;
   
      static int finding_period;
      static int killtype;
   
      static boolean mouse_pressed = false;
   
      static boolean show_exhaust;
      static boolean check_collisions = true;
   
      static int bit_density = 512; // divided by 1024
   
      static int period;
      static int a_atgrid = 0;
   
      static boolean paused; // should be boolean...
      static int stepping = 0;
   
      static int point_count_max = 67;
      static int point_count = 0;
   
      static int percentage_covered = 0;
      final static int CRITICAL_PERCENTAGE = 20;
   
      static int temp;
      static int temp2;
      static int last_temp;
      static int value;
      static int temp_distance;
   
      static int start_type;
   
      final static boolean crippled_version = true;
   
      final static Color colour_grey1 = new Color(0xB0B0B0);
   
      static boolean button_virginity = true;
   
      static boolean statusShown = true;
      private static volatile Thread recalc;
   
      final static int xoff = 4;
      final static int yoff = 4;
   
      static Font bold_font = new Font("Dialog", Font.BOLD, 12);
   
      // static JUR rnd = new JUR();
      static Hortensius32Fast rnd = new Hortensius32Fast();
      static Date HAL_date = new Date();
   
      static int cx;
      static int cy;
   
      static int x2;
      static int y2;
   
      static int bit;
   
      static int n0, s0, e0, w0;
      static int c0, c1;
   
      static int debug = 0;
   
      static int last_mousex;
      static int last_mousey;
   
      static long lastime = 0, newtime = 0, current_time;
   
      static int application = 0; //
   
      final static int MSGQ_SIZE = 32;
   
      static int dragged_x_offset;
      static int dragged_y_offset;
   
      static Entity dragged_entity;
      static Entity selected_entity;
      static Entity pointer_entity;
      static Entity end_entity;
      static Entity temp_entity;
   
      static Link temp_link;
      static Link selected_link;
      static EntityManager entity_manager;
   
      // Java enumerations...
   
      // messages...
      final static int MSG_NULL          = 0;
      final static int MOUSE_CLICK       = 1;
      final static int MOUSE_DRAG        = 2;
      final static int MOUSE_ENTRY       = 3;
      final static int MOUSE_RELEASE     = 4;
      final static int MOUSE_PRESSED     = 5;
      final static int MSG_CLEAR         = 6;
      final static int MSG_STEP          = 7;
      final static int MSG_PAUSE         = 8;
      final static int MSG_STOP          = 9;  // stop threads...
      final static int MSG_REVERSE       = 10;
      final static int MSG_SET           = 11;
      final static int MSG_ADDITION      = 12;
      final static int MSG_DENSITY_RESET = 13;
      final static int MSG_NEW_TYPE      = 14;
      final static int MSG_FREEZE        = 15;
      final static int MSG_MELT          = 16;
      final static int MSG_RECT          = 17;
      final static int MSG_HEX           = 18;
      final static int MSG_SOD           = 19;
      final static int MSG_WOLF          = 20;
      final static int MSG_NEW_CELLS     = 21;
      final static int MSG_CANCEL        = 22;
      final static int MSG_SETNEWSIZE    = 23;
      final static int MSG_PERIOD_FIND   = 24;
      final static int MSG_RESET_HISTORY = 25;
      final static int MSG_TRIUMPHANT    = 26;
      final static int MSG_CHANGE_AGENT_NUMBER  = 27;
      final static int MSG_CHANGE_AGENT_NUMBER2 = 28;
      final static int MSG_DB                   = 29;
      final static int MSG_RESTART              = 30;
      final static int MSG_RESIZE               = 31;
      final static int MSG_CONTROL              = 32;
      final static int MSG_LINKLENGTH           = 33;
      final static int MSG_DELETE               = 34;
      final static int MSG_DESELECT_NODES       = 35;
      final static int MSG_DESELECT_LINKS       = 36;
      final static int MSG_ALTERSIZE            = 37;
      final static int MSG_ALTERE               = 38;
      final static int MSG_REPRODUCTION         = 39;
      final static int MSG_BLEACHLINKS          = 40;
   
      // resolutions
      final static int _RES_VHIGH  = 512;
      final static int _RES_HIGH   = 256;
      final static int _RES_MEDIUM = 128;
      final static int _RES_LOW    = 64;
      final static int _RES_VLOW   = 32;
      final static int _RES_TINY   = 16;
      final static int _RES_VTINY  = 8;
      final static int _RES_MINUTE = 4;
   
      final static int _CLEAR          = 0;
      final static int _SET            = 1;
      final static int _MAKEWALL       = 2;
      final static int _CLEARWALL      = 3;
      final static int _RANDOMISE      = 4;
      // final static int _MAKESINK       = 5;
      final static int _MAKESOURCE     = 5;
   
      final static int _PENCIL  = 0;
      final static int _BRUSH   = 1;
      final static int _MACHINE = 2;
      final static int _SPRAY   = 3;
      final static int _POTATO  = 4;
   
      final static int _FRAME_1  = 0;
      final static int _FRAME_2  = 1;
      final static int _FRAME_4  = 3;
      final static int _FRAME_8  = 7;
      final static int _FRAME_16 = 15;
      final static int _FRAME_32 = 31;
   
      final static int _DELAY_0   = 0;
      final static int _DELAY_1   = 1;
      final static int _DELAY_2   = 2;
      final static int _DELAY_5   = 5;
      final static int _DELAY_10  = 10;
      final static int _DELAY_20  = 20;
      final static int _DELAY_50  = 50;
      final static int _DELAY_100 = 100;
      final static int _DELAY_200 = 200;
      final static int _DELAY_512 = 512;
   
      final static int _ACT_MOVE       = 0;
      final static int _ACT_DELETE     = 1;
      final static int _ACT_GROW       = 2;
      final static int _ACT_SHRINK     = 3;
      final static int _ACT_LINK       = 4;
      final static int _ACT_UNLINK     = 5;
      final static int _ACT_UNLINKALL  = 6;
      final static int _ACT_FREEZE     = 7;
      final static int _ACT_MELT       = 8;
      final static int _ACT_SETCOLOUR  = 9;
      final static int _ACT_READCOLOUR = 10;
      final static int _ACT_BLIND      = 11;
      final static int _ACT_SIGHT      = 12;
      final static int _ACT_FOLLOW     = 13;
      final static int _ACT_IGNORE     = 14;
      final static int _ACT_DRAG       = 15;
      final static int _ACT_DONTDRAG   = 16;
      final static int _ACT_FEAR       = 17;
      final static int _ACT_KILL       = 18;
      final static int _ACT_KILLALL    = 19;
      final static int _ACT_SELECT     = 20;
      final static int _ACT_CLONE      = 21;
   
      final static int _BOGGLERS        = 0;
      final static int _WORMS           = 1;
      final static int _FOOTBALLERS     = 2;
      final static int _AMOEBA          = 3;
      final static int _TADPOLES        = 4;
      final static int _SMALLAMOEBA     = 5;
      final static int _SPIDERPLANTS    = 6;
      final static int _SPIDERS         = 7;
      final static int _SMALLSPINES     = 8;
      final static int _SPERM           = 9;
      final static int _MIXTURE         = 10;
   
      final static int _SIMPLE    = 0;
      final static int _SIZES     = 1;
   
      final static int _QUALITY_0  = 0;
      final static int _QUALITY_1  = 1;
      final static int _QUALITY_1A = 2;
      final static int _QUALITY_2  = 3;
      final static int _QUALITY_2A = 4;
      final static int _QUALITY_3  = 5;
      final static int _QUALITY_3A = 6;
      final static int _QUALITY_4  = 7;
      final static int _QUALITY_4A = 8;
   
      static int quality;
   
   	// strings...
      final static String ADDITION      = "Add";
      final static String REPRODUCTION  = "Repro";
      final static String CLEAR         = "Clear";
      final static String RESTART       = "Restart";
   
      final static String SETSIZE       = "Resize";
   
      final static String STEP          = "Step";
      final static String STEPPING      = "Stepping";
      final static String PAUSE         = "Paused";
      final static String CANCEL        = "Cancel";
      final static String PERIOD_FIND   = "Find period";
      final static String FINDINGPERIOD = "Finding period";
      final static String HISTORY_RESET = "Reset history";
      final static String DB            = "Double buffering";
      final static String EX            = "Show exhaust";
      final static String LINKZ         = "Active links";
      final static String CC            = "Detect collisions";
      final static String OSCD          = "Use O(n^2) algorithm";
      final static String CONTROL       = "Controls";
   
      final static String NATIVE        = "Test native generator";
   
      final static String REVERSE       = "Reverse";
      final static String DENSITY_SET   = "X";
   
      static String stateChangedString;
      // AWT
   
      // Panels
      static Panel panelA;
      static Panel panelA2;
      static Panel panelB;
      static Panel panelB2;
      static Panel panelC;
      static Panel panelD;
      static Panel panel_active_links;
      static Panel panelD2;
      static Panel panelE;
      static Panel panelF;
      static Panel panelF2;
      static Panel panelF3;
      static Panel panelF4;
      static Panel panelF5;
      static Panel panelF6;
      static Panel panelF7;
      static Panel panel_link_length;
      static Panel panelG;
      static Panel panelG2;
      static Panel panelG3;
      static Panel panelG4;
      static Panel panelG5;
      static Panel panelG6;
      static Panel panelG7;
      static Panel panelG8;
      static Panel panelH;
      static Panel panelH2;
      static Panel panelI;
      static Panel panelJ;
      static Panel panelK;
      static Panel panelL;
      static Panel panel_control;
      static Panel panel_restart;
      static Panel panel_addition;
      static Panel panel_reproduction;
      static Panel panel_pause;
      static Panel panel_step;
      static Panel panel_step_size;
      static Panel panel_clear;
      static Panel panel_bleachedlinks;
      static Panel panel_noc;
      static Panel panelP;
      static Panel panelP1;
      static Panel panelP2;
      static Panel panelP3;
      static Panel panelP4;
      static Panel panelQ;
      static Panel panelR;
      static Panel panelS;
      static Panel panelT;
      static Panel panelU;
      static Panel panelV;
      static Panel panelW;
      static Panel panelW2;
   
      static Panel panelX;
      static Panel panelY;
      static Panel panelZ;
   
      //AdjustmentListener adjustment_listener = new AdjustmentListener();
   
      static Scrollbar scroll_bar_n;
      static Scrollbar scroll_bar_n2;
      static Scrollbar scroll_bar_bias;
      static Scrollbar scroll_bar_friction;
      static Scrollbar scroll_bar_limit;
      static Scrollbar scroll_bar_accel;
      static Scrollbar scroll_bar_size;
      static Scrollbar scroll_bar_eggsize;
      static Scrollbar scroll_bar_gravity;
      static Scrollbar scroll_bar_like;
      static Scrollbar scroll_bar_piston;
      static Scrollbar scroll_bar_impact;
      static Scrollbar scroll_bar_noc;
   
      static Shoals_Canvas shoals_canvas;
   
      // buttons...
      static Button button_restart;
      static Button button_addition;
      static Button button_reproduction;
      static Button button_clear;
      static Button button_randomise;
      static Button button_set;
      static Button button_step;
      static Button button_setsize;
      static Button button_colour_set;
      static Button button_colour_fix;
      static Button button_size_set;
      static Button button_size_fix;
      static Button button_e_set;
      static Button button_e_fix;
      static Button button_delete;
      static Button button_immune;
      static Button button_immortal;
      static Button button_deselnodes;
      static Button button_desellinks;
      static Button button_deselall;
      static Button button_follow;
      static Button button_fear;
      static Button button_drag;
      static Button button_ignore;
      static Button button_round;
      static Button button_hollow;
   
   	// checkboxes
      static Checkbox checkbox_pause;
      static Checkbox checkbox_control;
      static Checkbox checkbox_simplesize;
      static Checkbox checkbox_complexsize;
      static Checkbox checkbox_db;
      static Checkbox checkbox_exhaust;
      static Checkbox checkbox_boundaries;
      static Checkbox checkbox_linkz;
      static Checkbox checkbox_cc;
      static Checkbox checkbox_oscd;
      static Checkbox checkbox_longlinks;
      static Checkbox checkbox_shortlinks;
      static Checkbox checkbox_bleachedlinks;
   
   	// labels
      static Label label_show_gen;
      static Label label_show_time;
      static Label label_show_cells;
      static Label label_cell_count;
      static Label label_show_set;
      static Label label_resolution;
      static Label label_size_x;
      static Label label_size_y;
      static Label label_step_size;
      static Label label_history_size;
      static Label label_number;
      static Label label_number2;
      static Label label_bias;
      static Label label_friction;
      static Label label_limit;
      static Label label_size;
      static Label label_eggsize;
      static Label label_accel;
      static Label label_gravity;
      static Label label_like;
      static Label label_impact;
      static Label label_noc;
   
      // text fields
      static TextField textfield_colour_w;
      static TextField textfield_colour_r;
   
      static TextField textfield_size_r;
      static TextField textfield_size_w;
      static TextField textfield_e_r;
      static TextField textfield_e_w;
   
      static TextField textfield_size_x;
      static TextField textfield_size_y;
      static TextField textfield_step_size;
   
   	// colours
      static Color WorldColour    = Color.black;
      static Color GridColour     = Color.black;
      static Color PageColour     = Color.gray; // new Color(0xF0,0xE8,0xFF);
   
      static Color[] colours;
   
      static int kill_type        = _SET;
   
      static int weapon_type      = _POTATO;
   
      static int resolutionx;
      static int resolutiony;
   
      static int initial_type      = _MIXTURE; // _AMOEBA; // _SPERM;
      static int frame_frequency   = _FRAME_1;
   
      static int delay             = _DELAY_0;
   
      static int action_left_type  = _ACT_KILLALL;
      static int action_right_type = _ACT_KILL;
   
      static int busy = 0;
      static int old_busy_percentage = -1;
      static String busy_message;
      static Applet applet;
   
   // ...........................Methods........................
      public void init() {
      }
   
   
      public void start() {
         applet = this;
         resolutionx     = 144;
         resolutiony     = 110;
      
         Shoals_Grid.initialise(resolutionx,resolutiony);
      
         shoals_canvas = new Shoals_Canvas(this);
      
         // Shoals_Grid.shoals_canvas = shoals_canvas;
      
         paused = false;
         // delay = 0;
      
         if (gas_sim) {
            show_exhaust = false;
            quality = _QUALITY_4;
         }
         else
         {
            show_exhaust = true;
            quality = _QUALITY_4;
         }
      
         // Panels ADDED HERE
         panelX = new Panel();
         panelX.setLayout(new GridLayout(0,1,0,0));
         panelY = new Panel();
         panelZ = new Panel();
         panelZ.setLayout(new GridLayout(1,0,0,0));
      
         panelA = new Panel();
         panelA2 = new Panel();
         panelB = new Panel();
         panelB2 = new Panel();
         panelC = new Panel();
         panelD = new Panel();
         panel_active_links = new Panel();
         panelD2 = new Panel();
         panelE = new Panel();
         panelF = new Panel();
         panelF2 = new Panel();
         panelF3 = new Panel();
         panelF4 = new Panel();
         panelF5 = new Panel();
         panelF6 = new Panel();
         panelF7 = new Panel();
         panel_link_length = new Panel();
         panelG = new Panel();
         panelG2 = new Panel();
         panelG3 = new Panel();
         panelG4 = new Panel();
         panelG5 = new Panel();
         panelG6 = new Panel();
         panelG7 = new Panel();
         panelG8 = new Panel();
         panelH = new Panel();
         panelH2 = new Panel();
         panelI = new Panel();
         panelJ = new Panel();
         panelK = new Panel();
         panelL = new Panel();
         panel_control       = new Panel();
         panel_restart       = new Panel();
         panel_reproduction  = new Panel();
         panel_addition      = new Panel();
         panel_pause         = new Panel();
         panel_step          = new Panel();
         panel_step_size     = new Panel();
         panel_clear         = new Panel();
         panel_bleachedlinks = new Panel();
         panel_noc           = new Panel();
         panelP = new Panel();
         panelP1 = new Panel();
         panelP2 = new Panel();
         panelP3 = new Panel();
         panelP4 = new Panel();
         panelQ = new Panel();
         panelR = new Panel();
         panelS = new Panel();
         panelT = new Panel();
         panelU = new Panel();
         panelV = new Panel();
         panelW = new Panel();
         panelW2 = new Panel();
      
         this.setBackground(Color.black);
      
         panelY.setBackground(PageColour);
         panelX.setBackground(Color.lightGray);
         panelZ.setBackground(Color.lightGray);
      
         choose_start = new TTChoice(this); //??? 
      
         // start with...
         panel_noc.setBackground(colour_grey1);
         panel_noc.setLayout(new BorderLayout(0,8));
         panel_noc.add("West",new Label("Creatures:",Label.RIGHT));
      
         scroll_bar_noc = new Scrollbar(Scrollbar.HORIZONTAL,0,10,0,110);
         scroll_bar_noc.addAdjustmentListener(this);
      
         panel_noc.add("Center",scroll_bar_noc);
      
         label_noc = new Label("XXX",Label.LEFT);
         panel_noc.add("East",label_noc);
      
      	// start with...
         panelA.setBackground(colour_grey1);
         panelA.setLayout(new BorderLayout(0,8));
         panelA.add("West",new Label("N:",Label.RIGHT));
      
         scroll_bar_n = new Scrollbar(Scrollbar.HORIZONTAL,0,100,0,1100);
         scroll_bar_n.addAdjustmentListener(this); // adjustment_listener);
      
         panelA.add("Center",scroll_bar_n);
      
         label_number = new Label("XXX",Label.LEFT);
         panelA.add("East",label_number);
      
         // reflectNumber1();
      
         panelA2.setBackground(colour_grey1);
         panelA2.setLayout(new BorderLayout(0,8));
         panelA2.add("West",new Label("Eggs:",Label.RIGHT));
      
         scroll_bar_n2 = new Scrollbar(Scrollbar.HORIZONTAL,0,100,0,1100);
         scroll_bar_n2.addAdjustmentListener(this); // adjustment_listener);
      
         panelA2.add("Center",scroll_bar_n2);
      
         label_number2 = new Label("XXX",Label.LEFT);
         panelA2.add("East",label_number2);
      
         //reflectNumbers();
         reflectNumbers();
      
      	// weapon...
         // panelB.setBackground(colour_grey1);
         // panelB.add(new Label("Use",Label.RIGHT));
         panelB.setBackground(colour_grey1);
         checkbox_db = new Checkbox(DB);
         // checkbox_db.setState(true);
      
         checkbox_db.addItemListener(this);
      
         panelB.add(checkbox_db);
      
         checkbox_oscd = new Checkbox(OSCD);
         checkbox_oscd.addItemListener(this);
      
         panelB2.add(checkbox_oscd);
      
      	// action...
         panelC.setBackground(colour_grey1);
         panelC.setLayout(new BorderLayout(0,8));
         panelC.add("West",new Label("Bias:",Label.RIGHT));
      
         scroll_bar_bias = new Scrollbar(Scrollbar.HORIZONTAL,0,90,-180,270);
         scroll_bar_bias.addAdjustmentListener(this);
      
         panelC.add("Center",scroll_bar_bias);
      
         label_bias = new Label("  0",Label.LEFT);
         panelC.add("East",label_bias);
      
         // piston
         panelP.setLayout(new BorderLayout(0,8));
         scroll_bar_piston = new Scrollbar(Scrollbar.VERTICAL,1000,50,0,1050);
         scroll_bar_piston.addAdjustmentListener(this);
      
         panelP.add("Center",scroll_bar_piston);
      
      	// display...
      	/*
         checkbox_exhaust = new Checkbox(EX);
         checkbox_exhaust.setState(show_exhaust);
         checkbox_exhaust.addItemListener(this);
         panelD.add(checkbox_exhaust);
      	*/
      
         checkbox_boundaries = new Checkbox("Boundaries");
         checkbox_boundaries.setState(boundaries);
         checkbox_boundaries.addItemListener(this);
         panelD.add(checkbox_boundaries);
      
         // panel_active_links.setBackground(colour_grey1);
         checkbox_linkz = new Checkbox(LINKZ);
         checkbox_linkz.setState(use_links);
         checkbox_linkz.addItemListener(this);
         panel_active_links.add(checkbox_linkz);
      
         panelE.setBackground(colour_grey1);
         checkbox_cc = new Checkbox(CC);
         checkbox_cc.setState(true);
         checkbox_cc.addItemListener(this);
         panelE.add(checkbox_cc);
      
         CheckboxGroup checkbox_size_type = new CheckboxGroup();
      
         checkbox_simplesize = new Checkbox("" , checkbox_size_type, true);
         checkbox_simplesize.addItemListener(this);
      
         checkbox_complexsize = new Checkbox("" , checkbox_size_type, true);
         checkbox_complexsize.addItemListener(this);
      
      	// frame frequency...
         panelF.add(new Label("Show",Label.RIGHT));
      
         choose_frequency = new TTChoice(this);
         choose_frequency.add("every frame"       ,_FRAME_1);
         choose_frequency.add("every other frame" ,_FRAME_2);
         choose_frequency.add("one frame in four" ,_FRAME_4);
         choose_frequency.add("one frame in eight",_FRAME_8);
         //choose_frequency.add("frames rarely"     , _FRAME_16);
         // choose_frequency.add("very few frames"   ,_FRAME_32);
         choose_frequency.choice.select(choose_frequency.num_to_str(frame_frequency));
         panelF.add(choose_frequency.choice);
      
         // how to use...
         panelF2.setBackground(colour_grey1);
         panelF2.add(new Label("Left-click to",Label.RIGHT));
         choose_left_action = new TTChoice(this);
         choose_left_action.add("infect"   ,_ACT_KILLALL);
         choose_left_action.add("kill"       ,_ACT_KILL);
         //choose_left_action.add("move"       ,_ACT_MOVE);
         choose_left_action.add("select"     ,_ACT_SELECT);
         choose_left_action.add("delete"     ,_ACT_DELETE);
         choose_left_action.add("grow"       ,_ACT_GROW);
         choose_left_action.add("shrink"     ,_ACT_SHRINK);
         choose_left_action.add("link"       ,_ACT_LINK);
         choose_left_action.add("unlink"     ,_ACT_UNLINK);
         choose_left_action.add("clone"      ,_ACT_CLONE);
         choose_left_action.add("follow"     ,_ACT_FOLLOW);
         choose_left_action.add("fear"       ,_ACT_FEAR);
         choose_left_action.add("ignore"     ,_ACT_IGNORE);
         choose_left_action.add("sight"      ,_ACT_SIGHT);
         choose_left_action.add("blind"      ,_ACT_BLIND);
         choose_left_action.add("freeze"     ,_ACT_FREEZE);
         choose_left_action.add("melt"       ,_ACT_MELT);
         choose_left_action.add("drag"       ,_ACT_DRAG);
         choose_left_action.add("don't drag" ,_ACT_DONTDRAG);
         choose_left_action.add("read colour",_ACT_READCOLOUR);
         choose_left_action.add("set colour" ,_ACT_SETCOLOUR);
         choose_left_action.add("unlink all" ,_ACT_UNLINKALL);
      
         choose_left_action.choice.select(choose_left_action.num_to_str(action_left_type));
         panelF2.add(choose_left_action.choice);
      
      	// how to use...
         panelF3.setBackground(colour_grey1);
         panelF3.add(new Label("Right-click to",Label.RIGHT));
         choose_right_action = new TTChoice(this);
         choose_right_action.add("infect"   ,_ACT_KILLALL);
         choose_right_action.add("kill"       ,_ACT_KILL);
         //choose_right_action.add("move"       ,_ACT_MOVE);
         choose_right_action.add("select"     ,_ACT_SELECT);
         choose_right_action.add("delete"     ,_ACT_DELETE);
         choose_right_action.add("grow"       ,_ACT_GROW);
         choose_right_action.add("shrink"     ,_ACT_SHRINK);
         choose_right_action.add("link"       ,_ACT_LINK);
         choose_right_action.add("unlink"     ,_ACT_UNLINK);
         choose_right_action.add("clone"      ,_ACT_CLONE);
         choose_right_action.add("follow"     ,_ACT_FOLLOW);
         choose_right_action.add("fear"       ,_ACT_FEAR);
         choose_right_action.add("ignore"     ,_ACT_IGNORE);
         choose_right_action.add("sight"      ,_ACT_SIGHT);
         choose_right_action.add("blind"      ,_ACT_BLIND);
         choose_right_action.add("freeze"     ,_ACT_FREEZE);
         choose_right_action.add("melt"       ,_ACT_MELT);
         choose_right_action.add("drag"       ,_ACT_DRAG);
         choose_right_action.add("don't drag" ,_ACT_DONTDRAG);
         choose_right_action.add("read colour",_ACT_READCOLOUR);
         choose_right_action.add("set colour" ,_ACT_SETCOLOUR);
         choose_right_action.add("unlink all" ,_ACT_UNLINKALL);
         choose_right_action.choice.select(choose_right_action.num_to_str(action_right_type));
         panelF3.add(choose_right_action.choice);
      
         panelF4.add(new Label("Colour:",Label.RIGHT));
         textfield_colour_r = new TextField("0",2);
         textfield_colour_r.setColumns(2);
         textfield_colour_r.setEditable(false);
         panelF4.add(textfield_colour_r);
         button_colour_fix = new Button(">");
         button_colour_fix.setActionCommand("COLOURFIX");
         button_colour_fix.addActionListener(this);
         panelF4.add(button_colour_fix);
         textfield_colour_w = new TextField("511",2);
         textfield_colour_w.setColumns(2);
         panelF4.add(textfield_colour_w);
         button_colour_set = new Button("Set");
         button_colour_set.setActionCommand("COLOURSET");
         button_colour_set.addActionListener(this);
         panelF4.add(button_colour_set);
      
         panelF6.add(new Label("Size:",Label.RIGHT));
         textfield_size_r = new TextField("0",3);
         textfield_size_r.setColumns(2);
         textfield_size_r.setEditable(false);
         panelF6.add(textfield_size_r);
         button_size_fix = new Button(">");
         button_size_fix.setActionCommand("SIZEFIX");
         button_size_fix.addActionListener(this);
         panelF6.add(button_size_fix);
         textfield_size_w = new TextField("100",3);
         textfield_size_w.setColumns(2);
         panelF6.add(textfield_size_w);
         button_size_set = new Button("Set");
         button_size_set.setActionCommand("SIZESET");
         button_size_set.addActionListener(this);
         panelF6.add(button_size_set);
      
         panelF7.add(new Label("E:",Label.RIGHT));
         textfield_e_r = new TextField("0",3);
         textfield_e_r.setColumns(2);
         textfield_e_r.setEditable(false);
         panelF7.add(textfield_e_r);
         button_e_fix = new Button(">");
         button_e_fix.setActionCommand("EFIX");
         button_e_fix.addActionListener(this);
         panelF7.add(button_e_fix);
         textfield_e_w = new TextField("100",3);
         textfield_e_w.setColumns(2);
         panelF7.add(textfield_e_w);
         button_e_set = new Button("Set");
         button_e_set.setActionCommand("ESET");
         button_e_set.addActionListener(this);
         panelF7.add(button_e_set);
      
         button_delete = new Button("Delete");
         button_delete.setActionCommand("DELETE");
         button_delete.addActionListener(this);
         panelP1.add(button_delete);
      
         button_hollow = new Button("Hollow");
         button_hollow.setActionCommand("HOLLOW");
         button_hollow.addActionListener(this);
         panelP1.add(button_hollow);
      
         button_round = new Button("Round");
         button_round.setActionCommand("ROUND");
         button_round.addActionListener(this);
         panelP1.add(button_round);
      
         button_follow = new Button("Chase");
         button_follow.setActionCommand("FOLLOW");
         button_follow.addActionListener(this);
         panelP2.add(button_follow);
      
         button_fear = new Button("Fear");
         button_fear.setActionCommand("FEAR");
         button_fear.addActionListener(this);
         panelP2.add(button_fear);
      
         button_drag = new Button("Drag");
         button_drag.setActionCommand("DRAG");
         button_drag.addActionListener(this);
         panelP2.add(button_drag);
      
         button_ignore = new Button("Ignore");
         button_ignore.setActionCommand("IGNORE");
         button_ignore.addActionListener(this);
         panelP2.add(button_ignore);
      
         button_immune = new Button("Immune");
         button_immune.setActionCommand("IMMUNE");
         button_immune.addActionListener(this);
         panelP4.add(button_immune);
      
         button_immortal = new Button("Immortal");
         button_immortal.setActionCommand("IMMORTAL");
         button_immortal.addActionListener(this);
         panelP4.add(button_immortal);
      
         panelP3.add(new Label("Deselect",Label.RIGHT));
         button_deselnodes = new Button("nodes");
         button_deselnodes.setActionCommand("DESELECT_NODES");
         button_deselnodes.addActionListener(this);
         panelP3.add(button_deselnodes);
      
         button_desellinks = new Button("links");
         button_desellinks.setActionCommand("DESELECT_LINKS");
         button_desellinks.addActionListener(this);
         panelP3.add(button_desellinks);
      
         button_deselall = new Button("all");
         button_deselall.setActionCommand("DESELECT_ALL");
         button_deselall.addActionListener(this);
         panelP3.add(button_deselall);
      
         panelF5.add(new Label("Links are",Label.RIGHT));
         choose_link_display = new TTChoice(this);
         choose_link_display.add("solid"      ,Link.SOLID);
         choose_link_display.add("dotted"     ,Link.DOTTED);
         choose_link_display.add("circle"     ,Link.CIRCLE);
         choose_link_display.add("point"      ,Link.POINT);
         choose_link_display.add("invisible"  ,Link.INVISIBLE);
         choose_link_display.choice.select(choose_link_display.num_to_str(Link.link_display_type));
         panelF5.add(choose_link_display.choice);
      
         CheckboxGroup checkbox_linklength = new CheckboxGroup();
      
         panel_link_length.add(new Label("...and...",Label.RIGHT));
         checkbox_shortlinks = new Checkbox("short" , checkbox_linklength, true);
         checkbox_shortlinks.addItemListener(this);
      
         checkbox_longlinks = new Checkbox("long" , checkbox_linklength, false);
         checkbox_longlinks.addItemListener(this);
      
         panel_link_length.add(checkbox_shortlinks);
         panel_link_length.add(checkbox_longlinks);
      
         panel_bleachedlinks.add(new Label("...and...",Label.RIGHT));
         checkbox_bleachedlinks = new Checkbox("bleached" , false);
         checkbox_bleachedlinks.addItemListener(this);
      
         panel_bleachedlinks.add(checkbox_bleachedlinks);
      
      	// frame frequency...
         panelR.setBackground(colour_grey1);
         panelR.add(new Label("Delay:",Label.RIGHT));
         choose_delay = new TTChoice(this);
         choose_delay.add("0"     ,_DELAY_0);
         choose_delay.add("1"     ,_DELAY_1);
         choose_delay.add("2"     ,_DELAY_2);
         choose_delay.add("5"     ,_DELAY_5);
         choose_delay.add("10"    ,_DELAY_10);
         choose_delay.add("20"    ,_DELAY_20);
         choose_delay.add("50"    ,_DELAY_50);
         choose_delay.add("100"   ,_DELAY_100);
         choose_delay.add("200"   ,_DELAY_200);
         choose_delay.add("512"   ,_DELAY_512);
         choose_delay.choice.select(choose_delay.num_to_str(delay));
         panelR.add(choose_delay.choice);
      
         panelV.setBackground(colour_grey1);
         panelW.setBackground(colour_grey1);
         panelW2.setBackground(colour_grey1);
      
      	// friction.
         //panelG.setBackground(colour_grey1);
         panelG.setLayout(new BorderLayout(0,8));
         panelG.add("West",new Label("Friction:",Label.RIGHT));
      
         scroll_bar_friction = new Scrollbar(Scrollbar.HORIZONTAL,0,100,0,356);
         scroll_bar_friction.addAdjustmentListener(this);
         panelG.add("Center",scroll_bar_friction);
      
         label_friction = new Label("12",Label.LEFT);
         panelG.add("East",label_friction);
         reflectFriction();
      
         //limit
         panelG2.setBackground(colour_grey1);
         panelG2.setLayout(new BorderLayout(0,8));
         panelG2.add("West",new Label("Speed:",Label.RIGHT));
      
         scroll_bar_limit = new Scrollbar(Scrollbar.HORIZONTAL,Entity.max_velocity >> 5,50,0,450);
         scroll_bar_limit.addAdjustmentListener(this);
         panelG2.add("Center",scroll_bar_limit);
      
         label_limit = new Label("" + (Entity.max_velocity >> 5),Label.LEFT);
         panelG2.add("East",label_limit);
      
      	// rest energy
         // panelG8.setBackground(colour_grey1);
         panelG8.setLayout(new BorderLayout(0,8));
         panelG8.add("West",new Label("Excite:",Label.RIGHT));
      
         scroll_bar_impact = new Scrollbar(Scrollbar.HORIZONTAL,entity_manager.minimum_magnitude >> 6,10,0,109);
         scroll_bar_impact.addAdjustmentListener(this);
         panelG8.add("Center",scroll_bar_impact);
      
         label_impact = new Label("" + (entity_manager.minimum_magnitude >> 6),Label.LEFT);
         panelG8.add("East",label_impact);
      
         // accel
         panelG3.setBackground(colour_grey1);
         panelG3.setLayout(new BorderLayout(0,8));
         panelG3.add("West",new Label("Like:",Label.RIGHT));
      
         scroll_bar_accel = new Scrollbar(Scrollbar.HORIZONTAL,0x0,100,0,600);
         scroll_bar_accel.addAdjustmentListener(this);
      
         panelG3.add("Center",scroll_bar_accel);
      
         label_accel = new Label("64",Label.LEFT);
         panelG3.add("East",label_accel);
         reflectLike();
      
         // size
         panelG4.setLayout(new BorderLayout(0,8));
         panelG4.add("West",new Label("Size:",Label.RIGHT));
      
         scroll_bar_size = new Scrollbar(Scrollbar.HORIZONTAL,20,20,2,70);
         scroll_bar_size.addAdjustmentListener(this);
         panelG4.add("Center",scroll_bar_size);
      
         label_size = new Label("XX",Label.LEFT);
         panelG4.add("East",label_size);
      
         // eggsize
         // panelG5.setBackground(colour_grey1);
         panelG5.setLayout(new BorderLayout(0,8));
         panelG5.add("West",new Label("Egg size:",Label.RIGHT));
      
         scroll_bar_eggsize = new Scrollbar(Scrollbar.HORIZONTAL,48,20,2,147);
         scroll_bar_eggsize.addAdjustmentListener(this);
      
         panelG5.add("Center",scroll_bar_eggsize);
      
         label_eggsize = new Label("XXX",Label.LEFT);
         panelG5.add("East",label_eggsize);
      
         reflectSizes();
      
         // gravity
         panelG6.setBackground(colour_grey1); // ter
         panelG6.setLayout(new BorderLayout(0,8));
         panelG6.add("West",new Label("Gravity:",Label.RIGHT));
      
         scroll_bar_gravity = new Scrollbar(Scrollbar.HORIZONTAL,10,80,0,580);
         scroll_bar_gravity.addAdjustmentListener(this);
      
         panelG6.add("Center",scroll_bar_gravity);
      
         label_gravity = new Label("" + entity_manager.gravity,Label.LEFT);
         panelG6.add("East",label_gravity);
      
         // pointer affinity
         // panelG7.setBackground(colour_grey1);
         panelG7.setLayout(new BorderLayout(0,8));
         panelG7.add("West",new Label("Follow:",Label.RIGHT));
      
         scroll_bar_like = new Scrollbar(Scrollbar.HORIZONTAL,0x00,80,0,580);
         scroll_bar_like.addAdjustmentListener(this);
      
         panelG7.add("Center",scroll_bar_like);
      
         label_like = new Label("192",Label.LEFT);
         panelG7.add("East",label_like);
         reflectFollow();
      
         panelH.setBackground(colour_grey1);
         panelH.add(new Label("Quality:",Label.RIGHT));
      
         choose_quality = new TTChoice(this);
         choose_quality.add("best"      ,_QUALITY_0);
         choose_quality.add("medium"    ,_QUALITY_2);
         choose_quality.add("< medium"  ,_QUALITY_2A);
         choose_quality.add("poor"      ,_QUALITY_1);
         choose_quality.add("< poor"    ,_QUALITY_1A);
         choose_quality.add("terrible"  ,_QUALITY_3);
         choose_quality.add("< terrible",_QUALITY_3A);
         choose_quality.add("abysmal"   ,_QUALITY_4);
         choose_quality.add("< abysmal",_QUALITY_4A);
         choose_quality.choice.select(choose_quality.num_to_str(quality));
         panelH.add(choose_quality.choice);
      
         // addition
         button_addition = new Button(ADDITION);
         button_addition.addActionListener(this);
         button_addition.setFont(bold_font);
         panel_addition.setLayout(new BorderLayout(0,0));
         panel_addition.add(button_addition);
      
      	 // reproduction
         button_reproduction = new Button(REPRODUCTION);
         button_reproduction.addActionListener(this);
         button_reproduction.setFont(bold_font);
         panel_reproduction.setLayout(new BorderLayout(0,0));
         panel_reproduction.add(button_reproduction);
      
         // panelH2.setBackground(colour_grey1);
         // panelH2.add(new Label("Add",Label.RIGHT));
      
         choose_initial = new TTChoice(this);
         choose_initial.add("mixture"       ,_MIXTURE);
         choose_initial.add("sperm"         ,_SPERM);
         choose_initial.add("tadpoles"      ,_TADPOLES);
         choose_initial.add("worms"         ,_WORMS);
         choose_initial.add("snakes"        ,_BOGGLERS);
         choose_initial.add("footballers"   ,_FOOTBALLERS);
         choose_initial.add("amoebas"       ,_AMOEBA);
         choose_initial.add("bacteria"      ,_SMALLAMOEBA);
         choose_initial.add("spiders"       ,_SPIDERS);
         choose_initial.add("spiney"        ,_SMALLSPINES);
         choose_initial.add("plants"        ,_SPIDERPLANTS);
      
         choose_initial.choice.select(choose_initial.num_to_str(initial_type));
         panelH2.add(choose_initial.choice);
      
         // panelD2.setBackground(colour_grey1);
         panelD2.add(new Label("Use",Label.RIGHT));
      
         choose_tool = new TTChoice(this);
         choose_tool.add("a pencil"       ,_PENCIL);
         choose_tool.add("a brush"        ,_BRUSH);
         choose_tool.add("a toothbrush"   ,_MACHINE);
         choose_tool.add("an aerosol"     ,_SPRAY);
         choose_tool.add("potato printing",_POTATO);
         choose_tool.choice.select(choose_tool.num_to_str(weapon_type));
         panelD2.add(choose_tool.choice);
      
         // panelK.setBackground(colour_grey1);
         panelK.add(new Label("Generation:",Label.RIGHT));
         label_show_gen = new Label("0       ",Label.LEFT);
         panelK.add(label_show_gen);
      
         // panelL.setBackground(colour_grey1);
         panelL.add(new Label("Time/gen:",Label.RIGHT));
         label_show_time = new Label("0  ",Label.LEFT);
         panelL.add(label_show_time);
      
         //panelP.add(new Label("Set proportion:",Label.RIGHT));
         //label_show_set = new Label("0.000000000",Label.LEFT);
         //panelP.add(label_show_set);
      
         label_step_size = new Label("size:",Label.RIGHT);
      
      // Step...
         // 
         // panel_pause.setBackground(colour_grey1);
         button_step = new Button(STEP);
         button_step.addActionListener(this);
         button_step.setFont(bold_font);
         // panel_step.setLayout(new BorderLayout(0,0));
         panel_step_size.add(button_step);
      
         textfield_step_size = new TextField("1",0); // max columns?
         panel_step_size.add(label_step_size);
         panel_step_size.add(textfield_step_size);
      
      	// pause...
         checkbox_pause = new Checkbox(PAUSE);
         checkbox_pause.addItemListener(this);
      	// panel_pause.setLayout(new BorderLayout(0,0));
         panel_pause.add(checkbox_pause);
      
         panel_control.setBackground(colour_grey1);
         checkbox_control = new Checkbox(CONTROL);
         checkbox_control.addItemListener(this);
         checkbox_control.setState(controls_visible);
         panel_control.add(checkbox_control);
      
      	// restart
         button_restart = new Button(RESTART);
         button_restart.addActionListener(this);
         button_restart.setFont(bold_font);
         button_restart.setForeground(Color.red);
         panel_restart.setLayout(new BorderLayout(0,0));
         panel_restart.add(button_restart);
      
      	// clear
         button_clear = new Button(CLEAR);
         button_clear.addActionListener(this);
         button_clear.setFont(bold_font);
         button_clear.setForeground(Color.red);
         panel_clear.setLayout(new BorderLayout(0,0));
         panel_clear.add(button_clear);
      
         reflectMaxSpeed();
      
         setLayout(new BorderLayout(0,0));
      
         add("South",panelZ);
         add("East",panelX);
         if (development_version) {
            add("West",panelP);
         }
      
         add("Center",(Canvas)shoals_canvas);
      
         panelX.add(panel_noc);
         if (development_version) {
            panelX.add(panelA);
            panelX.add(panelG4);
         }
      
         panelX.add(panelA2);
      
         panelX.add(panelG5);
         // panelX.add(panelC);
      
         //panelX.add(panelQ);
      
         panelX.add(panelG2);
         panelX.add(panelG);
      
         panelX.add(panelG6);
         panelX.add(panelG8); //follow...
      
         if (!gas_sim) {
            panelX.add(panelG3); // acc...
            panelX.add(panelG7); //follow...
            panelX.add(panelC); // bias...
         }
      
         panelX.add(panelF); // show:
      
         panelX.add(panelH); // quality
         panelX.add(panelF5); // link display
         panelX.add(panel_link_length); // link len
         panelX.add(panel_bleachedlinks);
      
         panelX.add(panelR);
      
         panelX.add(panelD2);
      
         panelX.add(panelF2); // left mb
         panelX.add(panelF3); // right mb
         panelX.add(panelF4);
         panelX.add(panelF6);
         panelX.add(panelF7);
         panelX.add(panelP1);
         panelX.add(panelP2);
         panelX.add(panelP3);
         panelX.add(panelP4);
      
         panelX.add(panelE); // detect collsions
         panelX.add(panel_active_links);
      
         panelX.add(panelB); // double-buffering
      
         if (development_version) {
            panelX.add(panelB2); // OSCD n^2 collisions
         }
      
         //if (!gas_sim) {
            // panelX.add(panelD); // exhaust
            // panelX.add(panelD); // boundaries...
      
         //}
      
         panelZ.add(panel_step_size);
         // panelZ.add(panel_step);
         panelZ.add(panel_pause);
      
         panelZ.add(panelH2); // start type
      
         if (development_version) {
            panelZ.add(panel_reproduction);
         }
      
         panelZ.add(panel_addition);
         panelZ.add(panel_clear);
         panelZ.add(panel_restart);
      
         panelZ.add(panel_control);
      
         grey_selected_one();
         grey_selected_two();
      
         msgq = new TTMessage[MSGQ_SIZE];
      
         for (int c = 0; c < MSGQ_SIZE; c++) {
            msgq[c] = new TTMessage(0,0,0);
         }
      
         // Shoals_Grid.noboids();
         Shoals_Grid.newboids();
      
         ordered_start();
      
         shoals_canvas.start_up();
      
         recalc = new Thread(this);
      
         recalc.start();
      
         if (application != 0) {
            resize(320,512);
         }
      
         getDocBase();
      }
   
   
      public static void reflectNumbers() {
         reflectNumber1();
         reflectNumber2();
      }
   
   
      public static void reflectNumber1() {
         scroll_bar_n.setValue(entity_manager.number_of_agents);
      
         label_number.setText("" + entity_manager.number_of_agents);
      }
   
   
      public static void reflectNumber2() {
         scroll_bar_n2.setValue(entity_manager.number_of_leaders);
      
         label_number2.setText("" + entity_manager.number_of_leaders);
      }
   
   
      public static void reflectNOC() {
         scroll_bar_noc.setValue(Selection.max_number_of_creatures);
      
         label_noc.setText("" + Selection.max_number_of_creatures);
      }
   
   
      public static void reflectSizes() {
         reflectSize1();
         reflectSize2();
      }
   
   
      public static void reflectSize1() {
         scroll_bar_size.setValue(entity_manager.general_size);
      
         label_size.setText("" + entity_manager.general_size);
      }
   
   
      public static void reflectSize2() {
         scroll_bar_eggsize.setValue(entity_manager.general_eggsize);
      
         label_eggsize.setText("" + entity_manager.general_eggsize);
      }
   
   
      public static void reflectFollow() {
         scroll_bar_like.setValue(entity_manager.acc_of_leader);
      
         label_like.setText("" + entity_manager.acc_of_leader);
      }
   
   // 
      public static void reflectLike() {
         scroll_bar_accel.setValue(entity_manager.towards_leader >> 8);
      
         label_accel.setText("" + (entity_manager.towards_leader >> 8));
      }
   
   
      public static void reflectMaxSpeed() {
         scroll_bar_limit.setValue(Entity.max_velocity >> 5);
      
         label_limit.setText("" + (Entity.max_velocity >> 5));
      }
   
   
      public static void reflectImpact() {
         scroll_bar_impact.setValue(entity_manager.minimum_magnitude >> 6);
      
         label_impact.setText("" + (entity_manager.minimum_magnitude >> 6));
      }
   
   
      public static void reflectFriction() {
         scroll_bar_friction.setValue(Entity.friction_strength);
      
         label_friction.setText("" + (Entity.friction_strength));
      }
   
   
   
   
      public static void setUpResolutionSelector() {
        /* panelE.removeAll();
      
         choose_resolution.removeAll();
      
         panelE.setBackground(colour_grey1);
      
         panelE.add(label_resolution);
      
         String appendedstring = "(x3)";
      
         choose_resolution.add("8x8 "     + appendedstring ,_RES_VTINY);
         choose_resolution.add("16x16 "   + appendedstring ,_RES_TINY);
         choose_resolution.add("32x32 "   + appendedstring ,_RES_VLOW);
         choose_resolution.add("64x64 "   + appendedstring ,_RES_LOW);
         choose_resolution.add("128x128 " + appendedstring ,_RES_MEDIUM);
         choose_resolution.add("256x256 " + appendedstring ,_RES_HIGH);
      // temp = 
         choose_resolution.choice.select(choose_resolution.num_to_str(32)); // if possible...?
         choose_resolution.choice.select(choose_resolution.num_to_str(resolutionx)); // if possible...?
      
         panelE.add(choose_resolution.choice); */
      }
   
   
      public static void setUpResolutionSelector2() {
         panelQ.removeAll();
         panelQ.setBackground(colour_grey1);
         panelQ.add(label_size_x);
         panelQ.add(textfield_size_x);
         panelQ.add(label_size_y);
         panelQ.add(textfield_size_y);
      
         panelQ.add(button_setsize);
      }
   
   
      public static void random_start() {
      }
   
   
      public static void ordered_start() {
         reflectNumbers();
         reflectSizes();
         reflectFollow();
         reflectLike();
         reflectMaxSpeed();
         reflectFriction();
         reflectImpact();
         reflectNOC();
      
         Shoals_Grid.RepaintAll = true;
      }
   
   
      public void getDocBase() {
         try {
            Shoals_Input.document_base = getCodeBase();
         }
            catch (Exception e) {
               try {
                  String s = System.getProperty("user.dir");
                  Shoals_Input.document_base = new URL("file:/" + s + "/");
               }
                  catch (Exception e2) {
                     debug("Error: " + e2.toString());
                  }
            }
      }
   
   /*
      public static void init_loop() {
         switch (start_type) {
            case _SIMPLE:
               make_loop(100,600,1,"ACCCCCCCCCBBBBBBBBBD");
               make_loop(300,300,1,"ACCCBCCCBCCCBCCCBCCCD");
               make_loop(500,450,1,"ABCBCBCBCBCBCBCBCBCD");
               make_loop(700,300,1,"ABBBCBBBCBBBCBBBCBBBD");
               make_loop(900,600,1,"ABBBBBBBBBCCCCCCCCCD");
            
               break;
         
            case _SIZES:
               make_loop(100,300,1,"ABD");
               make_loop(200,350,1,"ACBCD");
               make_loop(300,400,1,"ABBCBBD");
               make_loop(400,450,1,"ACCCBCCCD");
               make_loop(500,500,1,"ABBBBCBBBBD");
               make_loop(600,550,1,"ACCCCCBCCCCCD");
               make_loop(700,600,1,"ABBBBBBCBBBBBBD");
               make_loop(800,650,1,"ACCCCCCCBCCCCCCCD");
               make_loop(900,700,1,"ABBBBBBBBCBBBBBBBBD");
            
               break;
         }
      
         Shoals_Grid.RepaintAll = true;
      }
   */
   
   /*
      public static void make_loop(int not, String instruct) {
         make_loop(rnd.nextInt(),rnd.nextInt(),not,instruct);
      }
   
   
      private static String preprocess(String instruct, int not) {
         String newstring = "";
         int temp = 0;
         int len = instruct.length();
         char c;
      
         while (temp < len) {
         
            c = instruct.charAt(temp++);
            if (c > '9')
               newstring = newstring + c;
            else
            {
               temp2 = (c) - '0';
               if (temp2 < 3)
                  temp2 += 10;
               c = instruct.charAt(temp++);
               for (last_temp = 0; last_temp < temp2; last_temp++) {
                  newstring = newstring + c;
               }
            }
         }
      
         if (not >= 2)
            newstring += newstring;
         if (not == 4)
            newstring += newstring;
      
         return newstring;
      }
   
   
      public static void make_loop(int x, int y, int not, String instruct) {
         int a;
         // int dir = Shoals_Grid.SOUTH;
         int loi;
         int nv = 0;
         int n2 = 0;
      
         int cx = 0;
         int cy = 0;
      
         int c;
         int talker = 0;
      
         instruct = preprocess(instruct, not);
      
         cx = (x * (Shoals_Grid.hside)) >>> 10;
         cy = (y * (Shoals_Grid.vside)) >>> 10;
      
         loi = instruct.length();
         for (a = 0; a < loi; a++) {
         
            c = ((int)instruct.charAt(a)) - 64;
            nv = c;
         
            temp = ((int)instruct.charAt(loi - a - 1)) - 64;
         
            if ((cx >= 0) && (cx < Shoals_Grid.hside) && (cy >= 0) && (cy < Shoals_Grid.vside)) {
               Shoals_Grid.in_grid[cx][cy] = c; //  | (Shoals_Grid.reproduction_delay_min << 16);
            }
         
            cy++;
         }
      }
   */
   
      public static void probablyDecrementx() {
         if ((cy & 1) != 0) {
            cx--;
         }
      }
   
   
      public static void clearAll() {
      }
   
   
      public static void clearStateBits() {
      		/*
         for (cx = Shoals_Grid.hside; cx-- > 0; ) {
            for (cy = Shoals_Grid.vside; cy-- > 0; ) {
               Shoals_Grid.in_grid[cx][cy] &= 0xffffff00;
            }
         }
      	*/
      }
   
   
      // .....................Run Method......................
      final public void run() {
         // System.out.println("90:" + Integer.toHexString(90) + " - 150: "+ Integer.toHexString(150));
      
         threadfinished = 0;
         threadnowfinished = 0;
      
         while (threadfinished == 0) {
            Shoals_Grid.calculate_grid();
            if (!paused) {
               if (stepping > 0) {
                  if (--stepping == 0) {
                     endStepping();
                  }
               }
            }
         
            if (Shoals_Grid.double_buffering) {
            
               if (current_message != 0)
                  handlemessages();
            
               Shoals_Grid.redraw_changed(Shoals_Canvas.image_handle);
            }
         
            if ((((Shoals_Grid.generation) & frame_frequency) == 0) || (paused)) {
               //if (frame_frequency > 16) {
                  //if (Shoals_Grid.double_buffering) {
                     //Shoals_Grid.redraw_changed(Shoals_Canvas.image_handle);
                 // }
               //}
            
               shoals_canvas.repaint();
            
               if (delay > 0) {
                  try {
                     recalc.sleep((long) delay);
                  } 
                     catch (InterruptedException e) {
                     }
               }
            
               updateStatus();
            
               recalc.yield();
            }
         }
      
         threadnowfinished = 1;
      
         recalc.yield();
      }
   
   
      final public static void endStepping() {
         stepping = 0;
         paused = true;
         grey_selected_three();
         button_step.setLabel(STEP);
      }
   
      final public void stop() {
         newmessage(MSG_STOP,0,0);
      /*
         recalc.yield();
      
         while (threadnowfinished == 0) {
            System.out.print("Apologies! ");
            recalc.yield();
         }
      	*/
      
         this.removeAll();
      }
   
   
      final static private void updateStatus() {
      		/*
         label_show_gen.setText("" + (Shoals_Grid.generation));
      
         if (frame_frequency < 14)
            temp = 15;
         else 
            temp = frame_frequency;
      
         if (((Shoals_Grid.generation) & temp) == 0) {
            newtime = System.currentTimeMillis();
            label_show_time.setText("" + ((newtime - lastime) / (temp + 1)));
            lastime = newtime;
         }
      	*/
      }
   
   
      final static void handlemessages() {
         int msgn = 0;
      
         for (msgn = 0; msgn < current_message; msgn++) {
            switch (msgq[msgn].type) {
               case MOUSE_DRAG:
                  HAL_mouseDragged(msgq[msgn].data1,msgq[msgn].data2);
               
                  break;
            
               case MOUSE_CLICK:
                  HAL_mouseClicked(msgq[msgn].data1,msgq[msgn].data2);
               
                  break;
            
               case MOUSE_PRESSED:
                  HAL_mousePressed(msgq[msgn].data1,msgq[msgn].data2);
               
                  break;
            
               case MOUSE_RELEASE:
                  HAL_mouseReleased(msgq[msgn].data1,msgq[msgn].data2);
               
                  break;
            
               case MOUSE_ENTRY:
                  HAL_mouseEntered(msgq[msgn].data1,msgq[msgn].data2);
               
                  break;
            
               case MSG_RESTART:
                  Shoals_Grid.noboids();
                  Shoals_Grid.newboids();
                  ordered_start();
               
                  break;
            
               case MSG_ADDITION:
                  Shoals_Grid.addBoids();
                  ordered_start();
               
                  break;
            
               case MSG_REPRODUCTION:
                  // debug("NOC:" + entity_manager.creature_manager.number_of_creatures);
                  if (entity_manager.creature_manager.number_of_creatures > 0) {
                     temp2 = entity_manager.creature_manager.number_of_creatures;
                     for (temp = 0; temp < temp2; temp++) {
                        entity_manager.creature_manager.duplicate(entity_manager.creature_manager.creature[temp], entity_manager);
                     }
                  }
               
                  ordered_start();
               
                  break;
            
               case MSG_BLEACHLINKS:
                  Link.bleached = !Link.bleached;
                  Shoals_Grid.RepaintAll = true;
               
                  break;
            
               case MSG_CLEAR:
                  Shoals_Grid.noboids();
               
                  ordered_start();
               
                  //creature_manager.killAllCreatures();
               
                  break;
            
               case MSG_RESIZE:
                  resolutionx = msgq[msgn].data1;
                  resolutiony = resolutionx;
                  performResize();
               
                  break;
            
               case MSG_SETNEWSIZE:
                  try {
                     resolutionx = Integer.parseInt(textfield_size_x.getText());
                  } 
                     catch (Exception e) {
                        resolutionx = 32;
                     }
               
                  try {
                     resolutiony = Integer.parseInt(textfield_size_y.getText());
                  } 
                     catch (Exception e) {
                        resolutiony = 32;
                     }
               
                  performResize();
               
                  break;
            
               case MSG_STEP:
                  paused = false;
               
                  // debug("STEPPED");  // works...
               
                  try {
                     stepping = Integer.parseInt(textfield_step_size.getText());
                     if (!Shoals_Grid.double_buffering) {
                        stepping++;
                     }
                  } 
                     catch (Exception e) {
                        stepping = 1;
                     }
               
                  grey_selected_three();
                  button_step.setLabel(CANCEL);
               
                  break;
            
               case MSG_STOP:
                  threadfinished = 1;
               
                  break;
            
               case MSG_CONTROL:
                  controls_visible = !controls_visible;
                  if (controls_visible) {
                     applet.add("East",panelX);
                  }
                  else
                  {
                     applet.remove(panelX);
                     // applet.removeAll();
                     // applet.setSize(2000,2000);
                     // applet.setLayout(new BorderLayout(0,8));
                      //applet.add("South",panelZ);
                  
                     // applet.add("East",panelX);
                     // applet.add("West",panelP);
                  
                     //shoals_canvas = new Shoals_Canvas((Shoals)applet); // needed...
                     // Shoals_Canvas.forceResize();
                  
                     // shoals_canvas.show();
                     // Shoals_Grid.shoals_canvas = shoals_canvas;
                  
                     // applet.add("Center",(Canvas)shoals_canvas);
                  
                     // applet.setVisible(true);
                     // applet.setSize(applet.getSize());
                  	// applet.show();
                  	// shoals_canvas.show();
                     // applet.remove((Canvas)shoals_canvas);
                     // applet.setSize(2000,2000);
                  }
               
                  // ordered_start();
                  // Shoals_Grid.set_size(10,10);
                  //Shoals_Canvas.forceResize();
                  // Shoals_Grid.RepaintAll = true;
                  // applet.hide();
                  // applet.show();
                  //
               // applet.isDoubleBuffered(controls_visible);
               
                  break;
            
               case MSG_CHANGE_AGENT_NUMBER:
                  entity_manager.target_number_of_agents = msgq[msgn].data1;
                  entity_manager.changeNumber();
               
                  label_number.setText("" + entity_manager.target_number_of_agents);
                  Shoals_Grid.RepaintAll = true;
               
                  break;
            
               case MSG_CHANGE_AGENT_NUMBER2:
                  entity_manager.target_number_of_leaders = msgq[msgn].data1;
                  entity_manager.changeLeaderNumber();
               
                  label_number2.setText("" + entity_manager.target_number_of_leaders);
                  Shoals_Grid.RepaintAll = true;
               
                  break;
            
               case MSG_DB:
                  Shoals_Grid.double_buffering = !Shoals_Grid.double_buffering;
                  Shoals_Grid.RepaintAll = true;
                  Shoals_Canvas.getImageHandle();
                  Shoals_Canvas.forceResize(); // gsx_old = -1; // force resize...
               
                  break;
            
               case MSG_PAUSE:
                  paused = !paused;
                  grey_selected_two();
               
                  break;
            
               case MSG_LINKLENGTH:
                  Link.link_display_length = msgq[msgn].data1;
                  Shoals_Grid.RepaintAll = true;
               
                  break;
            
               case MSG_CANCEL:
                  endStepping();
               
                  break;
            
               case MSG_DELETE:
                  entity_manager.deleteSelected();
                  entity_manager.link_manager.deleteSelected();
               
                  break;
            
               case MSG_DESELECT_NODES:
                  entity_manager.deselectAll();
               
                  break;
            
               case MSG_DESELECT_LINKS:
                  entity_manager.link_manager.deselectAll();
               
                  break;
            
               case MSG_ALTERSIZE:
                  entity_manager.setSizeOfSelected((byte)msgq[msgn].data1);
                  entity_manager.link_manager.setSizeOfSelected(msgq[msgn].data1);
               
                  break;
            
               case MSG_ALTERE:
                  entity_manager.link_manager.setElasticityOfSelected(msgq[msgn].data1);
               
                  break;
            
            		// case DESELECT_ALL:
            }
         }
      
         current_message = 0;
      
         if (mouse_pressed) {
            newmessage(MOUSE_CLICK,last_mousex,last_mousey);
         }
      }
   
   
      final static public void performResize() {
         Shoals_Canvas.forceResize();
         Shoals_Grid.set_size(resolutionx,resolutiony);
         ordered_start();
      }
   
   
      final static public void newmessage(int t, int d1, int d2) {
         if (current_message < MSGQ_SIZE) {
            msgq[current_message].type = t;
            msgq[current_message].data1 = d1;
            msgq[current_message].data2 = d2;
         
            current_message++;
         }
      }
   
   
      public void adjustmentValueChanged(AdjustmentEvent e) {
         if (e.getSource() == scroll_bar_n) {
            newmessage(MSG_CHANGE_AGENT_NUMBER,e.getValue(),0);
         }
      
         if (e.getSource() == scroll_bar_n2) {
            newmessage(MSG_CHANGE_AGENT_NUMBER2,e.getValue(),0);
         }
      
         if (e.getSource() == scroll_bar_noc) {
            Selection.max_number_of_creatures = e.getValue();
            label_noc.setText("" + Selection.max_number_of_creatures);
         }
      
         if (e.getSource() == scroll_bar_bias) {
            temp = e.getValue();
            Entity.direction_bias = (byte)((temp * 16) / 180);
            label_bias.setText("" + temp);
         }
      
         if (e.getSource() == scroll_bar_piston) {
            temp = e.getValue();
            entity_manager.piston = temp;
            Shoals_Grid.RepaintAll = true;
            Shoals_Grid.virgin_applet = 1;
         }
      
         if (e.getSource() == scroll_bar_friction) {
            temp = e.getValue();
            Entity.friction_strength = temp;
            label_friction.setText("" + temp);
         }
      
         if (e.getSource() == scroll_bar_limit) {
            temp = e.getValue();
            Entity.max_velocity = temp << 5;
            label_limit.setText("" + temp);
         }
      
         if (e.getSource() == scroll_bar_size) {
            temp = e.getValue();
            entity_manager.setGlobalSize((byte)temp);
            label_size.setText("" + temp);
            // Shoals_Grid.newboids();
            entity_manager.resetEntityGrid();
         
            Shoals_Grid.RepaintAll = true;
         }
      
         if (e.getSource() == scroll_bar_eggsize) {
            temp = e.getValue();
            entity_manager.setGlobalEggSize((byte)temp);
            label_eggsize.setText("" + temp);
            entity_manager.resetEntityGrid();
            // Shoals_Grid.newboids();
         
            Shoals_Grid.RepaintAll = true;
         }
      
         if (e.getSource() == scroll_bar_gravity) {
            temp = e.getValue();
            entity_manager.gravity = temp;
            label_gravity.setText("" + temp);
         }
      
         if (e.getSource() == scroll_bar_like) {
            temp = e.getValue();
            entity_manager.acc_of_leader = temp;
            label_like.setText("" + temp);
         }
      
         if (e.getSource() == scroll_bar_accel) {
            temp = e.getValue();
            entity_manager.towards_leader = temp << 8;
            label_accel.setText("" + temp);
         }
      
         if (e.getSource() == scroll_bar_impact) {
            temp = e.getValue();
            entity_manager.minimum_magnitude = temp << 6;
            label_impact.setText("" + temp);
         }
      }
   
      public void itemStateChanged(ItemEvent e) {
         if (e != null) {
            stateChangedString = (String)(e.getItem());
         }
      
         // action
         //if (choose_kill.str_to_num(stateChangedString) != -99) {
            //kill_type = choose_kill.str_to_num(stateChangedString);
         //}
      
         //if (choose_start.str_to_num(stateChangedString) != -99) {
            //start_type = choose_start.str_to_num(stateChangedString);
            //newmessage(MSG_RESTART,0,0);
         //}
      
         // weapon...
         if (choose_tool.str_to_num(stateChangedString) != -99) {
            weapon_type = choose_tool.str_to_num(stateChangedString);
         }
      
         // show
         //if (choose_display.str_to_num(stateChangedString) != -99) {
            //Shoals_Grid.display_type = choose_display.str_to_num(stateChangedString);
            //Shoals_Grid.smear_y = 0;
            //Shoals_Grid.RepaintAll = true;
         //}
      
         // restart
         if (choose_start.str_to_num(stateChangedString) != -99) {
            // HAL_Grid.start_type = choose_start.str_to_num(stateChangedString);
            newmessage(MSG_NEW_TYPE,0,0);
         }
      
         // res
         /*
         if (choose_resolution.str_to_num(stateChangedString) != -99) {
            temp = choose_resolution.str_to_num(stateChangedString);
            newmessage(MSG_RESIZE,temp,0);
         }
      	*/
      
         // frame frequency...
         if (choose_frequency.str_to_num(stateChangedString) != -99) {
            frame_frequency = choose_frequency.str_to_num(stateChangedString);
            Shoals_Grid.RepaintAll = true;
         }
      
         if (choose_initial.str_to_num(stateChangedString) != -99) {
            initial_type = choose_initial.str_to_num(stateChangedString);
         
            // newmessage(MSG_RESTART,0,0);
         }
      
      	// frame frequency...
         if (choose_left_action.str_to_num(stateChangedString) != -99) {
            if (e.getSource() == choose_left_action.choice) {
               action_left_type = choose_left_action.str_to_num(stateChangedString);
            }
         }
      
         if (choose_right_action.str_to_num(stateChangedString) != -99) {
            if (e.getSource() == choose_right_action.choice) {
               action_right_type = choose_right_action.str_to_num(stateChangedString);
            }
         }
      
      	// mutation rate...
         //if (choose_mutation.str_to_num(stateChangedString) != -99) {
          //  Shoals_Grid.mutation_rate = choose_mutation.str_to_num(stateChangedString);
         //}
      
      // radiation rate...
         //if (choose_radiation.str_to_num(stateChangedString) != -99) {
         //   Shoals_Grid.radiation_rate = choose_radiation.str_to_num(stateChangedString);
         //}
      
         //  delay selection...
         if (choose_delay.str_to_num(stateChangedString) != -99) {
            delay = choose_delay.str_to_num(stateChangedString);
         }
      
         if (choose_link_display.str_to_num(stateChangedString) != -99) {
            Link.link_display_type = choose_link_display.str_to_num(stateChangedString);
            Shoals_Grid.RepaintAll = true;
         }
      
      
      
      	// quality selection...
         if (choose_quality.str_to_num(stateChangedString) != -99) {
            quality = choose_quality.str_to_num(stateChangedString);
            Shoals_Grid.RepaintAll = true;
         }
      
         // pause?
         if (e.getSource() == checkbox_pause) { // stateChangedString.equals(PAUSE)) {
            newmessage(MSG_PAUSE,0,0);
         }
      
         if (e.getSource() == checkbox_shortlinks) {
            newmessage(MSG_LINKLENGTH,Link.SHORT,0);
         }
      
         if (e.getSource() == checkbox_bleachedlinks) {
            newmessage(MSG_BLEACHLINKS,0,0);
         }
      
         if (e.getSource() == checkbox_longlinks) {
            newmessage(MSG_LINKLENGTH,Link.LONG,0);
         }
      
      	 // pause?
         if (e.getSource() == checkbox_control) { // stateChangedString.equals(PAUSE)) {
            newmessage(MSG_CONTROL,0,0);
         }
      
      	// double buff
         if (stateChangedString.equals(DB)) {
            newmessage(MSG_DB,0,0);
         }
      
      	// double oscd
         if (stateChangedString.equals(OSCD)) {
            oscd = !oscd;
            // newmessage(MSG_OSCD,0,0);
         }
      
         if (e.getSource() == checkbox_boundaries) { // stateChangedString.equals(PAUSE)) {
            boundaries = !boundaries;
         }
      
      	// pause?
         if (stateChangedString.equals(EX)) {
            show_exhaust = !show_exhaust;
            Shoals_Grid.RepaintAll = true;
         }
      
         if (stateChangedString.equals(LINKZ)) {
            use_links = !use_links;
            Shoals_Grid.RepaintAll = true;
         }
      
         if (stateChangedString.equals(CC)) {
            check_collisions = !check_collisions;
         }
      }
   
   
      public void actionPerformed(ActionEvent e) {
         String arg = e.getActionCommand();
         Object source = e.getSource();
         // debug(arg);
      
         if (arg.equals(RESTART)) {
            newmessage(MSG_RESTART,0,0);
         }
         
         else if (arg.equals(ADDITION)) {
            newmessage(MSG_ADDITION,0,0);
         }
         
         else if (arg.equals(REPRODUCTION)) {
            newmessage(MSG_REPRODUCTION,0,0);
         }
         
         else if (arg.equals(CLEAR)) {
            newmessage(MSG_CLEAR,0,0);
         }
         
         else if (arg.equals(STEP)) {
            newmessage(MSG_STEP,0,0);
         }
         
         else if (arg.equals(SETSIZE)) {
            newmessage(MSG_SETNEWSIZE,0,0);
         }
         
         else if (arg.equals(CANCEL)) {
            newmessage(MSG_CANCEL,0,0);
         }
         
         else if (arg.equals("COLOURFIX")) {
            textfield_colour_w.setText(textfield_colour_r.getText());
         }
         
         else if (arg.equals("COLOURSET")) {
            //if (selected_entity != null) {
            entity_manager.setColourOfSelected(Integer.parseInt(textfield_colour_w.getText()));
            //}
         
            entity_manager.link_manager.setColourOfSelected(Integer.parseInt(textfield_colour_w.getText()));
            //if (selected_link != null) {
            //selected_link.colour = Integer.parseInt(textfield_colour_w.getText());
            //Shoals_Grid.RepaintAll = true;
            //}
         }
         
         else if (arg.equals("SIZEFIX")) {
            textfield_size_w.setText(textfield_size_r.getText());
         }
         
         else if (arg.equals("SIZESET")) {
            newmessage(MSG_ALTERSIZE,Integer.parseInt(textfield_size_w.getText()),0);
         }
         
         else if (arg.equals("EFIX")) {
            textfield_e_w.setText(textfield_e_r.getText());
         }
         
         else if (arg.equals("ESET")) {
            newmessage(MSG_ALTERE,Integer.parseInt(textfield_e_w.getText()),0);
         }
         
         else if (arg.equals("DELETE")) {
            newmessage(MSG_DELETE,0,0);
         }
         
         
         
         else if (arg.equals("DESELECT_NODES")) {
            newmessage(MSG_DESELECT_NODES,0,0);
         }
         
         else if (arg.equals("DESELECT_LINKS")) {
            newmessage(MSG_DESELECT_LINKS,0,0);
         }
         
         else if (arg.equals("DESELECT_ALL")) {
            newmessage(MSG_DESELECT_NODES,0,0);
            newmessage(MSG_DESELECT_LINKS,0,0);
         }
         
         else if (arg.equals("FOLLOW")) {
            entity_manager.affectStatusBits(-1 ^ Entity.FOLLOW ^ Entity.FEAR ^ Entity.DRAG, Entity.FOLLOW);
         }
         
         else if (arg.equals("FEAR")) {
            entity_manager.affectStatusBits(-1 ^ Entity.FOLLOW ^ Entity.FEAR ^ Entity.DRAG, Entity.FEAR);
         }
         
         else if (arg.equals("DRAG")) {
            entity_manager.affectStatusBits(-1 ^ Entity.FOLLOW ^ Entity.FEAR ^ Entity.DRAG, Entity.DRAG);
         }
         
         else if (arg.equals("IGNORE")) {
            entity_manager.affectStatusBits(-1 ^ Entity.FOLLOW ^ Entity.FEAR ^ Entity.DRAG, 0);
         }
         
         else if (arg.equals("ROUND")) {
            entity_manager.affectStatusBits(-1 ^ Entity.ALWAYS_CIRCULAR, Entity.ALWAYS_CIRCULAR);
         }
         
         else if (arg.equals("HOLLOW")) {
            entity_manager.affectStatusBits(-1 ^ Entity.ALWAYS_HOLLOW, Entity.ALWAYS_HOLLOW);
         }
         
         else if (arg.equals("IMMORTAL")) {
            entity_manager.affectStatusBits(-1 ^ Entity.IMMORTAL, Entity.IMMORTAL);
         }
         
         else if (arg.equals("IMMUNE")) {
            entity_manager.affectStatusBits(-1 ^ Entity.IMMUNE, Entity.IMMUNE);
         }
      }
   
   
      public static void grey_selected_one() {
      }
   
   
      public static void grey_selected_two() {
        // boolean flag = (paused != 0) ? true : false;
         button_step.setEnabled(paused);
      }
   
   
      public static void grey_selected_three() {
         // boolean flag = (paused != 0) ? true : false;
      
         checkbox_pause.setEnabled(paused);
         button_restart.setEnabled(paused);
         button_addition.setEnabled(paused);
         button_clear.setEnabled(paused);
         button_reproduction.setEnabled(paused);
      }
   
   
      public static void grey_selected_four() {
      }
   
   
      private static final void kill_a_line(int x, int y, int ox, int oy) {
         float _x = x;
         float _y = y;
         float dx, dy;
         float dis;
         float num;
      
         switch (weapon_type) {
            case _MACHINE:
               temp = 16;
               break;
         
            case _BRUSH:
               temp = 4;
               break;
         
            case _SPRAY:
               temp = 8;
               break;
         
            case _POTATO:
               temp = 12;
               break;
         
            default:
               temp = 1;
         }
      
         dis = ((SquareRoot.sqrt((((x - ox) * (x - ox)) + ((y - oy) * (y - oy))))) + 2) / 256;
      
         if (dis <= temp) {
            num = dis + 2;
         }
         else
         {
            num = (float)(dis / (float)temp);
         }
      
         if (num < 2) {
            num = 2;
         }
      
         dx = ((float)((ox - x) / num));
         dy = ((float)((oy - y) / num));
      
         for (int i = 0; i < (int)num; i++) {
            single_killing((int)_x,(int)_y);
            _x += dx;
            _y += dy;
         }
      }
   
   
      private static final void kill_a_cell(int x, int y) {
         temp_entity = entity_manager.isThereOne(x, y);
         if (temp_entity != null) {
            switch (killtype) {
               case _ACT_KILL:
                  if ((temp_entity.status & Entity.IMMORTAL) == 0) {
                     temp_entity.status = (temp_entity.status & (-1 - Entity.INITIAL_DEATH_STAGE)) | (Entity.INITIAL_DEATH_STAGE - rnd.nextInt(64) + Entity.SPREADING_DEATH);
                     entity_manager.creature_manager.killSpecifiedCreature(temp_entity.creature);
                  }
               
                  break;
            
               case _ACT_KILLALL:
                  if ((temp_entity.status & Entity.IMMUNE) == 0) {
                     temp_entity.status = (temp_entity.status & (-1 - Entity.INITIAL_DEATH_STAGE)) | (Entity.INITIAL_DEATH_STAGE - rnd.nextInt(64) + Entity.SPREADING_DEATH + Entity.DEADLY);
                     entity_manager.creature_manager.killSpecifiedCreature(temp_entity.creature);
                  }
               
                  break;
            
               case _ACT_DELETE:
                  killAllLinks(temp_entity);
                  entity_manager.killThisEntity(temp_entity);
            }
         }
      }
   
   
      public static void HAL_mouseClicked(int x,int y) {
      		// debug("MOD:" + Shoals_Canvas.modifiers);
         if ((Shoals_Canvas.modifiers & java.awt.event.InputEvent.BUTTON1_MASK) != 0) {
            actionSwitch(x,y,action_left_type);
         }
      
         if ((Shoals_Canvas.modifiers & java.awt.event.InputEvent.BUTTON3_MASK) != 0) {
            actionSwitch(x,y,action_right_type);
         }
      
         last_mousex = x;
         last_mousey = y;
      }
   
   
      public static void actionSwitch(int x,int y, int type) {
         switch (type) {
            /*case _ACT_MOVE:
               doDragging(x, y);
            
               break;*/
         
            case _ACT_DELETE:
               doDelete(x, y);
            
               break;
         
            case _ACT_GROW:
               doGrow(x, y);
            
               break;
         
            case _ACT_READCOLOUR:
               doReadColour(x, y);
            
               break;
         
            case _ACT_SETCOLOUR:
               doSetColour(x, y);
            
               break;
         
            case _ACT_BLIND:
               doBlind(x, y);
            
               break;
         
            case _ACT_SIGHT:
               doSight(x, y);
            
               break;
         
            case _ACT_SHRINK:
               doShrink(x, y);
            
               break;
         
            case _ACT_FREEZE:
               doFreeze(x, y);
            
               break;
         
            case _ACT_MELT:
               doMelt(x, y);
            
               break;
         
            case _ACT_LINK:
               doLink(x, y);
            
               break;
         
            case _ACT_UNLINK:
               doUnlink(x, y);
            
               break;
         
            case _ACT_UNLINKALL:
               doUnlinkAll(x, y);
            
               break;
         
            case _ACT_FOLLOW:
               doFollow(x, y);
            
               break;
         
            case _ACT_FEAR:
               doFear(x, y);
            
               break;
         
            case _ACT_IGNORE:
               doIgnore(x, y);
            
               break;
         
            case _ACT_DRAG:
               doDrag(x, y);
            
               break;
         
            case _ACT_DONTDRAG:
               doDontDrag(x, y);
            
               break;
         
            case _ACT_KILL:
               doKill(x, y);
            
               break;
         
            case _ACT_KILLALL:
               doKillAll(x, y);
            
               break;
         
            case _ACT_SELECT:
               doSelect(x, y);
            
               break;
         
            case _ACT_CLONE:
               doClone(x, y);
            
               break;
         }
      }
   
   
      public static void HAL_mousePressed(int x,int y) {
         HAL_mouseClicked(x, y);
      }
   
   
      // mouse button pressed...
      public static void HAL_mouseDragged(int x,int y) {
         HAL_mouseClicked(x, y);
      }
   
   
      public static void HAL_mouseEntered(int x,int y) {
         last_mousex = x;
         last_mousey = y;
      }
   
   
      public static void HAL_mouseReleased(int x,int y) {
         terminateLink(x, y);
         button_virginity = true;
      
         dragged_entity = null;
         pointer_entity = null;
         currently_dragging = false;
      }
   
   
      /*
      public static void doDragging(int x, int y) {
         if (button_virginity) {
            button_virginity = false;
            if (dragged_entity == null) {
               dragged_entity = entity_manager.isThereOne(x, y);
               if (dragged_entity != null) {
                  dragged_x_offset = x - dragged_entity.x;
                  dragged_y_offset = y - dragged_entity.y;
               }
            }
         }
      
         dragCurrentObject(x, y);
      }
   */
   
   
      public static void doDelete(int x, int y) {
         killtype = _ACT_DELETE;
      
         if (button_virginity) {
            button_virginity = false;
            single_killing(x,y);
         }
         else
         {  
            kill_a_line(x, y, last_mousex, last_mousey);
         }
      }
   
   
      public static void doKill(int x, int y) {
         killtype = _ACT_KILL;
      
         if (button_virginity) {
            button_virginity = false;
            single_killing(x,y);
         }
         else
         {  
            kill_a_line(x, y, last_mousex, last_mousey);
         }
      }
   
   
      public static void doKillAll(int x, int y) {
         killtype = _ACT_KILLALL;
      
         if (button_virginity) {
            button_virginity = false;
            single_killing(x,y);
         }
         else
         {  
            kill_a_line(x, y, last_mousex, last_mousey);
         }
      }
   
   
      public static void doGrow(int x, int y) {
         if (button_virginity) {
            button_virginity = false;
            dragged_entity = entity_manager.isThereOne(x, y);
            if (dragged_entity != null) {
               dragged_entity.scrub();
               dragged_entity.setSize((byte)(dragged_entity.diameter + 1));
               Shoals_Grid.RepaintAll = true;
            }
         }
      }
   
   
      public static void doSelect(int x, int y) {
         //if (button_virginity) {
            //button_virginity = false;
      
         if (!currently_dragging) {
            if ((Shoals_Canvas.modifiers & 3) == 0) {
               entity_manager.deselectAll();
               entity_manager.link_manager.deselectAll();
               selected_entity = null;
               selected_link = null;
            }
         
            selected_entity = entity_manager.isThereOne(x, y);
            // check for selected entity...
            if (selected_entity != null) {
               if ((Shoals_Canvas.modifiers & 2) != 0) {
                  if (button_virginity) {
                     selected_entity.status ^= Entity.SELECTED;
                     if ((selected_entity.status & Entity.SELECTED) == 0) {
                        Shoals_Grid.RepaintAll = true;
                     }
                  }
               }
               else
               {
                  selected_entity.status |= Entity.SELECTED;
               }
            
               textfield_colour_r.setText("" + (int)(selected_entity.colour));
               textfield_size_r.setText("" + selected_entity.diameter);
            }
            else // check for selected link...
            {
               selected_link = entity_manager.link_manager.isThereOne(x, y);
               if (selected_link != null) {
                  if ((Shoals_Canvas.modifiers & 2) != 0) {
                     if (button_virginity) {
                        selected_link.status ^= Link.SELECTED;
                        if ((selected_link.status & Link.SELECTED) == 0) {
                           Shoals_Grid.RepaintAll = true;
                        }
                     }
                  }
                  else
                  {
                     selected_link.status |= Link.SELECTED;
                  }
               
                  textfield_colour_r.setText("" + selected_link.colour);
                  textfield_size_r.setText("" + selected_link.upper_length_limit);
                  textfield_e_r.setText("" + selected_link.elasticity);
               }
            }
         }
      
         if (button_virginity) {
            button_virginity = false;
            // if (dragged_entity == null) {
            dragged_entity = entity_manager.isThereOne(x, y);
            if (dragged_entity != null) {
               if (dragged_entity.isSelected()) {
                  dragged_x_offset = x - dragged_entity.x;
                  dragged_y_offset = y - dragged_entity.y;
               }
            }
         }
         else
         {
            dragCurrentObject(x, y);
         }
      }
   
   
      public static void doClone(int x, int y) {
         if (button_virginity) {
            button_virginity = false;
            selected_entity = entity_manager.getSelectedEntity();
         
            if (selected_entity != null) {
               entity_manager.addNewAgent(x - (selected_entity.diameter >> 1), y - (selected_entity.diameter >> 1),
                                    selected_entity.colour, (byte)selected_entity.diameter,
                                    selected_entity.log_mass,
                                    selected_entity.status & (-1 ^ Entity.SELECTED));
            }
         }
      }
   
   
      public static void doDrag(int x, int y) {
         dragged_entity = entity_manager.isThereOne(x, y);
         if (dragged_entity != null) {
            dragged_entity.status |= Entity.DRAG;
         }
      }
   
   
      public static void doDontDrag(int x, int y) {
         dragged_entity = entity_manager.isThereOne(x, y);
         if (dragged_entity != null) {
            dragged_entity.status &= (-1 ^ Entity.DRAG);
         }
      }
   
   
      public static void doFreeze(int x, int y) {
         dragged_entity = entity_manager.isThereOne(x, y);
         if (dragged_entity != null) {
            dragged_entity.status |= Entity.FROZEN;
         }
      }
   
   
      public static void doMelt(int x, int y) {
         dragged_entity = entity_manager.isThereOne(x, y);
         if (dragged_entity != null) {
            dragged_entity.status &= (-1 ^ Entity.FROZEN);
         }
      }
   
   
      public static void doSight(int x, int y) {
         dragged_entity = entity_manager.isThereOne(x, y);
         if (dragged_entity != null) {
            dragged_entity.status |= Entity.EYE;
         }
      }
   
   
      public static void doFollow(int x, int y) {
         dragged_entity = entity_manager.isThereOne(x, y);
         if (dragged_entity != null) {
            dragged_entity.status |= Entity.FOLLOW;
         }
      }
   
   
      public static void doFear(int x, int y) {
         dragged_entity = entity_manager.isThereOne(x, y);
         if (dragged_entity != null) {
            dragged_entity.status |= Entity.FEAR;
         }
      }
   
   
      public static void doIgnore(int x, int y) {
         dragged_entity = entity_manager.isThereOne(x, y);
         if (dragged_entity != null) {
            dragged_entity.status &= (-1 ^ Entity.FOLLOW ^ Entity.FEAR);
         }
      }
   
   
      public static void doBlind(int x, int y) {
         dragged_entity = entity_manager.isThereOne(x, y);
         if (dragged_entity != null) {
            dragged_entity.status &= (-1 ^ Entity.EYE);
         }
      }
   
   
      public static void doReadColour(int x, int y) {
         dragged_entity = entity_manager.isThereOne(x, y);
         if (dragged_entity != null) {
            textfield_colour_r.setText("" + dragged_entity.colour);  // both...
            textfield_colour_w.setText("" + dragged_entity.colour);
         }
      }
   
   
      public static void doSetColour(int x, int y) {
         dragged_entity = entity_manager.isThereOne(x, y);
         if (dragged_entity != null) {
            dragged_entity.colour = (char)(Integer.parseInt(textfield_colour_w.getText()));
         }
      }
   
   
      public static void doShrink(int x, int y) {
         if (button_virginity) {
            button_virginity = false;
            dragged_entity = entity_manager.isThereOne(x, y);
            if (dragged_entity != null) {
               dragged_entity.scrub();
               dragged_entity.setSize((byte)(dragged_entity.diameter - 1));
               Shoals_Grid.RepaintAll = true;
            }
         }
      }
   
   
      public static void doLink(int x, int y) {
         // debug("LINK");
         if (button_virginity) {
            button_virginity = false;
            // debug("NO VIRGIN");
            if (dragged_entity == null) {
               dragged_entity = entity_manager.isThereOne(x, y);
               if (dragged_entity != null) {
                  pointer_entity = new Entity(x, y, 999);
                  entity_manager.link_manager.setLink(dragged_entity, pointer_entity, 60, 160, 511, 0);
               }
            }
         }
      
         dragNewLink(x, y);
      }
   
   
      public static void doUnlink(int x, int y) {
         if (dragged_entity == null) {
            dragged_entity = entity_manager.isThereOne(x, y);
            if (dragged_entity != null) {
               killLastLink(dragged_entity);
            }
         }
      }
   
   
      public static void doUnlinkAll(int x, int y) {
         if (dragged_entity == null) {
            dragged_entity = entity_manager.isThereOne(x, y);
            if (dragged_entity != null) {
               killAllLinks(dragged_entity);
            }
         }
      }
   
   
      public static void terminateLink(int x, int y) {
         if (pointer_entity != null) {
            if (dragged_entity != null) {
               end_entity = entity_manager.isThereOne(x, y);
               if (end_entity != null) {
                  temp_distance = entity_manager.distanceBetween(dragged_entity, end_entity); // in pixels...
                  if (temp_distance > 0) {
                     entity_manager.link_manager.deleteAllLinksBetween(dragged_entity, end_entity);
                     entity_manager.link_manager.setLink(dragged_entity, end_entity, temp_distance, 160, 511, 0);
                     // debug("D:" + temp_distance); // ok...
                  }
               }
            
               killAllLinks(pointer_entity);
            }
         }
      }
   
   
      public static void killAllLinks(Entity e) {
         entity_manager.link_manager.killAllLinks(e);
      
         Shoals_Grid.RepaintAll = true;
      }
   
   
      public static void killLastLink(Entity e) {
         entity_manager.link_manager.killLastLink(e);
      
         Shoals_Grid.RepaintAll = true;
      }
   
   
      public static void dragCurrentObject(int x, int y) {
         if (dragged_entity != null) {
            if (dragged_entity.isSelected()) {
               currently_dragging = true;
               temp = x - dragged_x_offset - dragged_entity.x;
               temp2 = y - dragged_y_offset - dragged_entity.y;
            
               entity_manager.moveSelection(temp, temp2);
            }
         }
      }
   
   
      public static void dragNewLink(int x, int y) {
         if (pointer_entity != null) {
            pointer_entity.x = x;
            pointer_entity.y = y;
         }
      }
   
   
      public static void single_killing(int x,int y) {
         switch (weapon_type) {
            case _PENCIL:
               kill_a_cell(x, y);
               break;
         
            case _BRUSH:
               circle_fill(x,y,0x2000,0);
               break;
         
            case _MACHINE:
               octagon_fill(x,y,0x5000,127);
               break;
         
            case _SPRAY:
               octagon_fill(x,y,0x3000,31);
               break;
         
            case _POTATO:
               circle_fill(x,y,0x4000,0);
               break;
         }
      
         reflectNumbers();
      }
   
   
      public static void octagon_fill(int x, int y, int r, int f) {
         for (cx = -r; cx < r; cx = cx + 0x800) {
            for (cy = -r; cy < r; cy = cy + 0x800) {
               if ((rnd.nextInt() & f) == 0) {
                  if (((cx + cy) > (r *-1.5)) && ((cx + cy) < (r*1.5)) && ((cx - cy) > (r *-1.5)) && ((cx - cy) < (r*1.5))) {
                     kill_a_cell(x + cx, y + cy);
                  }
               }
            }
         }
      }
   
   
      public static void circle_fill(int x, int y, int r, int f) {
         for (cx = -r; cx < r; cx = cx + 0x800) {
            for (cy = -r; cy < r; cy = cy + 0x800) {
               if ((rnd.nextInt() & f) == 0) {
                  if ((cx*cx + cy* cy) < r*r) {
                     kill_a_cell(x + cx, y + cy);
                  }
               }
            }
         }
      }
   
   
      public static void nowBusy(String message) {
         busy = 1;
         busy_message = message;
      	// busy_percentage = -1;
         old_busy_percentage = 0;
      
         cx = Shoals_Grid.hside * Shoals_Grid.gridsize;
         cy = Shoals_Grid.vside * Shoals_Grid.gridsize;
      
         int t = cx / 20;
         if (t < 10) 
            t = 10;
      
         if (Shoals_Canvas.image_handle != null) {
            Shoals_Canvas.image_handle.setColor(Color.black);
            Shoals_Canvas.image_handle.fillRect(0,0,9999,9999);
         
            Shoals_Canvas.image_handle.setFont(new Font("Helvetica", Font.BOLD, t));
         
            Shoals_Canvas.image_handle.setColor(Color.white);
            Shoals_Canvas.image_handle.drawString(Shoals.busy_message, (cx / 2) - (t * 4), (cy * 1) / 8);
            Shoals_Canvas.image_handle.drawString("Please be patient", (cx / 2) - (t * 4), (cy * 2) / 8);
         
            Shoals_Canvas.image_handle.drawRect(0, cy * 8/16, cx - 1, cy / 16);
         }
      
         shoals_canvas.repaint();
      }
   
   
      public static void notBusy() {
      /*
         busy = 0;
      
         Shoals_Grid.RepaintAll = true;
      
         shoals_canvas.repaint();
      */
      
      }
   
   
      public static void percentageBusy(int p) {
         cx = Shoals_Grid.hside * Shoals_Grid.gridsize;
         cy = Shoals_Grid.vside * Shoals_Grid.gridsize;
      
         int t = (Shoals_Grid.hside * Shoals_Grid.gridsize) / 13;
      
         if (t < 10) 
            t = 10;
      
         if (Shoals_Canvas.image_handle != null) {
            Shoals_Canvas.image_handle.setFont(new Font("Helvetica", Font.BOLD, t));
         
            Shoals_Canvas.image_handle.setColor(Color.black);
            Shoals_Canvas.image_handle.fillRect(cx * 2 / 5, (cy * 5) / 16, cx / 5, cy / 12);
         
            Shoals_Canvas.image_handle.setColor(Color.white);
            Shoals_Canvas.image_handle.drawString("" + p + "%", (cx / 2) - (t * 1), (cy * 3) / 8);
         
            temp = 3 + (((p - old_busy_percentage) * cx ) / 100);
            temp2 = 3 + (cx * old_busy_percentage) / 100;
            if (p == 100) {
               temp2 = cx - 3 - temp;
            }
         
            Shoals_Canvas.image_handle.setColor(Color.red);
            Shoals_Canvas.image_handle.fillRect(temp2, ((cy * 8) / 16) + 3, temp, (cy / 16) - 4);
         }
      
         old_busy_percentage = p;
      
         shoals_canvas.repaint();
      }
   
   
      // main method
      public static void main(String args[]) {
         Shoals applet = new Shoals();
      
         Shoals.application = 1;
      
         Frame frame = new TTAppletFrame("Shoals",(Applet)applet,760,640);
         frame.show();
      }
   
   
      public String getAppletInfo() {
         // return "Shoals - self-reproducting particle systems.";
         return "Shoals - self-reproducting simulated physical creatures.";
      }
   
   
      public static void redrawIfPaused() {
      }
   
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
