/*
 * Shoals_Input - Tim Tyler 2000-2000
 */

   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import java.io.*;
   import java.lang.Exception;
   import java.lang.Integer;
   import java.lang.Long;
   import java.lang.Object;
   import java.util.StringTokenizer;
   import java.util.Date;
   import java.awt.image.*;
   import java.lang.Character;
   import java.net.URL;
   import java.net.URLConnection;

   public class Shoals_Input {
      static int start_agent_number;
      static int temp;
      static int temp2;
   
      static Reader in;
      static Entity temp_entity;
      static Link temp_link;
      static Link current_link;
   
      static int current_object;
      static Entity current_entity;
   
      static Creature current_creature;
   
      static char c;
      static int index;
      static int i;
      static char buf[];
   
      static String number = "";
      static String token = "";
   
      static URL document_base;
   
      public static int in_token = 0;
      public static int in_number = 0;
      public static int in_instruction = 0;
      // public static int[] workspace;
      // public static int[] new_workspace;
   
      public static int size_of_workspace;
   
      public static int instruction_pointer;
      //public static int data_pointer;
      //public static int a; // accumulator...
   
      public static int current_instruction;
      public static int last_token_number;
   
      public static int offset;
      public static int count;
      public static int tip; // temp instruction pointer
      public static int t; // temp
      public static int t2; // temp
      public static int t3; // temp
      public static int endpoint; // temp
      public static int found; // flag
      public static int bound; // flag
      public static int match; // flag
      public static int current; // flag
   
      public static URL url;
      static PrivateWorld manager;
   
   
   
      public static String sout;
   
      final static boolean debug_parser = false;
   
   	/* Instructions: */
      final static String[] INS_NAMES = {
         "Agent",  // 0
         "Leader", // 1
         "Link",   // 2
         
         "X",      // 3
         "Y",      // 4
         "DX",     // 5
         "DY",     // 6
         "D",      // 7
         "Elasticity",   // 8
         "Number_one",   // 9
         "Number_two",   // 10
         "Upper_length_limit",   // 11
         "Lower_length_limit",   // 12
         "Colour",               // 13
         "E",       // 14
         "One",     // 15
         "Two",     // 16
         "ULL",     // 17
         "LLL",     // 18
         "C",       // 19
         "Status",  // 20
         
         "Creature",// 21
         "Key_Node",// 22
         "Data",    // 23
         "Read_point", // 24
         "Write_point",// 25
         "Egg",        // 26
         "Egg_attached", // 27
         "Fission" // 28
      };
   
      static int MAX_INS = INS_NAMES.length; // 26;
   
      public static void init() {
         // new_workspace = new int[8192];
         buf = new char[10000];
      
         MAX_INS = INS_NAMES.length;
      }
   
   
      public static void main (String args[]) {
         init();
      }
   
   
      public static void addFile(String filename) {
         readInShoalsFile(filename);
      }
   
      public static void loadFile(String filename) {
         resetWorkspaces();
         readInShoalsFile(filename);
      }
   
   
      public static void resetWorkspaces() {
         if (manager == Shoals.entity_manager) {
            Shoals.entity_manager.number_of_leaders = 0;
         }
      
         manager.number_of_agents = 0;
         manager.link_manager.number_of_links = 0;
      }
   
   
      public static void addFromString(String s, PrivateWorld m, int x, int y, int scale_factor) {
         manager = m;
         temp2 = s.length();
         char[] temp_str = new char[temp2];
         for (temp = 0; temp < (temp2 - 1); temp++) {
            temp_str[temp] = s.charAt(temp);
         }
      
         start_agent_number = manager.number_of_agents;
      
         interpretBuffer(temp_str, x, y, scale_factor);
      }
   
   
      public static void loadFromString(String s, PrivateWorld m, int x, int y, int scale_factor) {
         manager = m;
         resetWorkspaces();
      
         temp2 = s.length();
         char[] temp_str = new char[temp2];
         for (temp = 0; temp < (temp2 - 1); temp++) {
            temp_str[temp] = s.charAt(temp);
         }
      
         start_agent_number = 0;
      
         interpretBuffer(temp_str, x, y, scale_factor);
      }
   
   
   
   //E: filename
   //X: pointer to workspace filled with "byte-sized ints"...
      public static void readInShoalsFile(String filename) {
         init();
      
         //Shoals.entity_manager.number_of_leaders = 0;
         //Shoals.entity_manager.number_of_agents = 0;
         //LinkManager.number_of_links = 0;
      
         start_agent_number = Shoals.entity_manager.number_of_agents;
      
         index = 0;
      
         if (debug_parser) 
            System.out.println("Filename : " + filename);
      
         try {
            url = new URL(document_base ,filename);
         }
            catch (Exception e2) {
               System.out.println("TT_Error (readInShoalsFile I): " + e2.toString());
            }
      
      
         try {
            // System.out.println("URL:" + url.toString());
            InputStream in = url.openStream(); // may ask to connect to the network...?
            do {
               i = in.read();
               c = (char)i;
               if (i != -1) 
                  buf[index++] = c;
            } while (i != -1);
         }
            catch (Exception e) {
               System.out.println("TT_Error (readInShoalsFile 2): " + e.toString());
            }
      
         interpretBuffer(buf,0,0,256);
      }
   
   
      public static void interpretBuffer(char[] buf, int x, int y, int scale_factor) {
         index = buf.length;
         current_creature = null;
      
         in_token = 0;
         in_number = 0;
         in_instruction = 0;
         number = "";
         token = "";
         instruction_pointer = 0;
      
         for (i = 0; i < index; i++) {
            // debug("" + i);
            c = buf[i];
         
            // ignore commented lines...
            if (c == '#')
               do {
                  c = buf[++i];
               } while (c > 31);
         
            if (in_instruction == 0) {
               if (Character.isDigit(c)) { // start number...
                  in_number = 1;
                  in_instruction = 1;
                  number += c;
               }
               else
               {
                  if (Character.isLetter(c)) { // || (Character.isUpperCase(c))) { // start instruction...
                     in_token = 1;
                     in_instruction = 1;
                     token += c;
                  }
               }
            }
            else
            { // is in existing instruction...
               if (in_token != 0) {
                  if ((c >= '0') && (c != ':')) {
                     token += c;
                  }
                  else
                  { // finished token...
                     t = 0;
                     found = 0;
                     do {
                        if (token.equals(INS_NAMES[t++])) {
                           found = 1;
                           t--;
                        }
                     } while ((found == 0) && (t != MAX_INS));
                  
                     if (t == MAX_INS) {
                        if (debug_parser) 
                           System.out.println("Unknown token: " + token + " (ignored)");
                     } 
                     else
                     {
                        last_token_number = t;
                        switch (last_token_number) {
                           case 0:
                              manager.addNewAgent();
                           
                              current_entity = manager.agent[manager.number_of_agents - 1];// = last_token_number;
                              current_object = last_token_number;
                              current_entity.colour = 511;
                              current_entity.status = 0;
                           
                              if (current_creature != null) {
                                 current_creature.add(current_entity);
                              }
                           
                              break;
                        
                           case 1:
                              if (manager == Shoals.entity_manager) {
                                 Shoals.entity_manager.addNewLeader();
                                 current_entity = Shoals.entity_manager.leader[Shoals.entity_manager.number_of_leaders - 1];// = last_token_number;
                                 current_object = last_token_number;
                                 current_entity.colour = 508;
                                 current_entity.status = 0;
                              }
                           
                              break;
                        
                           case 2:
                              manager.link_manager.setLink();
                              current_link = manager.link_manager.entity_link[manager.link_manager.number_of_links - 1];// = last_token_number;
                              current_object = last_token_number;
                              current_link.colour = 255;
                           
                              break;
                        
                           case 21:
                              // creature_manager.add();
                              current_creature = manager.creature_manager.add(); // creature_manager.creature[creature_manager.number_of_creatures - 1];// = last_token_number;
                              current_creature.private_world = manager;
                           
                              current_object = last_token_number;
                           
                              break;
                        
                           case 24:
                              current_creature.read_entity = current_entity;
                              current_creature.genome.initial_read_entity = current_entity;
                           
                              break;
                        
                           case 25:
                              current_creature.write_entity = current_entity;
                              current_creature.genome.initial_write_entity = current_entity;
                           
                              break;
                        
                           case 26:
                              current_creature.egg = true;
                           
                              break;
                        
                           case 27:
                              current_creature.egg_attached = true;
                           
                              break;
                        
                           case 28:
                              current_creature.fission = true;
                           
                              break;
                        }
                     
                        if (debug_parser) 
                           debug("Token: " + token + " (" + t + ")");
                     }
                  
                     in_token = 0;
                     in_instruction = 0;
                     token = "";
                  }
               }
            
               if (in_number != 0) {
                  if (c >= '0') {
                     number += c;
                  }
                  else
                  { // finished number...
                     if ((number.length() >= 3) && (number.charAt(1) == 'x')) {
                        number = number.substring(2);
                        // new_workspace[instruction_pointer++] = (int)Long.parseLong(number,16);
                        if (debug_parser) 
                           System.out.println("Hex number: 0x" + number + " (" + (int)Long.parseLong(number,16) + ")");
                     }
                     else
                     {
                        temp = (int)Long.parseLong(number);
                     
                        switch (current_object) {
                           case 0: // agent
                           case 1: // leader
                              switch (last_token_number) {
                                 case 3:
                                    current_entity.x = ((temp * scale_factor) >> 8) + x;
                                 
                                    break;
                              
                                 case 4:
                                    current_entity.y = ((temp * scale_factor) >> 8) + y;
                                 
                                    break;
                              
                                 case 5:
                                    current_entity.dx = (temp * scale_factor) >> 8;
                                 
                                    break;
                              
                                 case 6:
                                    current_entity.dy = (temp * scale_factor) >> 8;
                                 
                                    break;
                              
                                 case 7:
                                    //current_entity.setInitialSize((byte)1, (byte)((temp * scale_factor) >> 8));
                                    current_entity.setInitialSize((byte)((temp * scale_factor) >> 8), (byte)((temp * scale_factor) >> 8));
                                 
                                    break;
                              
                                 case 13:
                                 case 19:
                                    current_entity.colour = (char)temp;
                                 
                                    break;
                              
                                 case 20:
                                    current_entity.status = temp;
                                 
                                    break;
                              
                              
                              }
                           
                              break;
                        
                           case 2:
                              // no links yet...
                              switch (last_token_number) {
                                 case 8:
                                 case 14:
                                    current_link.elasticity = temp;
                                 
                                    break;
                              
                                 case 9:
                                 case 15:
                                    temp_entity = manager.agent[temp + start_agent_number];
                                    temp_entity.addLink(current_link);
                                    current_link.entity1 = temp_entity;
                                 
                                    break;
                              
                                 case 10:
                                 case 16:
                                    temp_entity = manager.agent[temp + start_agent_number];
                                    temp_entity.addLink(current_link);
                                    current_link.entity2 = temp_entity;
                                 
                                    break;
                              
                                 case 11:
                                 case 17:
                                    // current_link.setInitialLength((byte)2, (temp * scale_factor) >> 8);
                                    current_link.setInitialLength((byte)((temp * scale_factor) >> 8), (temp * scale_factor) >> 8);
                                 
                                    break;
                              
                                 case 12:
                                 case 18:
                                    current_link.setInitialLength((byte)2, (temp * scale_factor) >> 8);
                                    // current_link.lower_length_limit = (temp * scale_factor) >> 8;
                                 
                                    break;
                              
                                 case 13:
                                 case 19:
                                    current_link.colour = temp;
                                 
                                    break;
                              
                                 case 20:
                                    current_link.status = temp;
                                 
                                    break;
                              }
                           
                              break;
                        
                           case 21: // creature...
                              switch (last_token_number) {
                                 case 23:
                                    // data...
                                    current_creature.genome.add(temp);
                                 
                                    break;
                              }
                        }
                     
                        if (debug_parser) {
                           System.out.println("Number: " + number);
                        }
                     }
                  
                     in_number = 0;
                     in_instruction = 0;
                     number = "";
                  }
               }
            }
         }
      
         if (current_creature != null) {
            if (current_creature.write_entity != null) {
               current_creature.write_link = current_creature.write_entity.list_of_links.link[0];
            }
         
            if (current_creature.read_entity != null) {
               current_creature.read_link = current_creature.read_entity.list_of_links.link[0];
            }
         }
      
         if (manager == Shoals.entity_manager) {
            Shoals.entity_manager.target_number_of_agents = Shoals.entity_manager.number_of_agents;
            Shoals.entity_manager.target_number_of_leaders = Shoals.entity_manager.number_of_leaders;
         
            Shoals.ordered_start();
         }
      
         // System.out.println("Parsing finished.");
      }
   
   
      final static void debug(String o) {
         System.out.println(o);
      }
   
   }
