/*
 * Creature - Tim Tyler 2000-2000.
 */

   public class Creature extends Object {
      Entity[] entity_list;
   
      int[] genome;
   
      int max_number_of_entities;
      int number_of_entities;
      int status;
   
      int genome_size;
   
      char age_of_creature;
      char age_of_puberty;
      char period_of_gestation;
      char age_when_next_fertile;
      char maximum_age;
   
      boolean egg;
      boolean egg_attached;
   
      byte number_of_kids_so_far;
   
      Entity read_entity;
      Entity write_entity;
   
      PrivateWorld private_world; // needed?
   
      Creature next_creature;    // used for reproduction...
      ListOfLinks list_of_links; // links between the corresponding cells of this creature and the next...
   
      // static variables...
      static int temp;
      static Entity[] new_entity_list;
      static Hortensius32Fast rnd = new Hortensius32Fast();
   
      final static int DEAD = 1 << 31;
   
      Creature() {
         max_number_of_entities = 1;
         entity_list = new Entity[max_number_of_entities];
      
         genome_size = 0;	
         genome = new int[genome_size];
      
         set();
      }
   
   
      final void set() {
         number_of_entities = 0;
         status = 0;
      
         number_of_kids_so_far = 0;
         age_of_creature = 0;
         age_of_puberty = (char)(64 + rnd.nextInt(32));
         period_of_gestation = 64;
         age_when_next_fertile = age_of_puberty;
         maximum_age = (char)(128 + rnd.nextInt(128));
      }
   
   
      final void add(Entity e) {
         if (number_of_entities >= max_number_of_entities) {
            makeMoreEntities();
         }
      
         entity_list[number_of_entities++] = e;
      
         e.creature = this;
      
      	//temp measure...
         // read_entity = e;
         // write_entity = e;
      }
   
   
     // again, this is wasteful :-|
      final void makeMoreEntities() {
         max_number_of_entities++;
      
         new_entity_list = new Entity[max_number_of_entities];
      
         for (temp = 0; temp < (max_number_of_entities - 1); temp++) {
            new_entity_list[temp] = entity_list[temp];
         }
      
         entity_list = new_entity_list;
      }
   
   
     // returns number within this creature...
      final int getEntityNumber(Entity e) {
         for (temp = 0; temp < number_of_entities; temp++) {
            if (entity_list[temp] == e) {
               return temp;
            }
         }
      
         // debug("Entity is not part of this creature"); 
      
         return -1;
      }
   
   
      final void markAsKilled() {
         status |= Creature.DEAD;
         // need to manually go through and destroy all references to this creature...
         for (temp = 0; temp < number_of_entities; temp++) {
            entity_list[temp].creature = null; // OK after all...
         }
      }
   
   
      final void beginToReproduce() {
         if (next_creature == null) {
            next_creature = new Creature();
         }
         else
         {
            next_creature.set();
         }
      
         if (list_of_links == null) {
            list_of_links = new ListOfLinks(); // links between the corresponding cells of this creature and the next...
         }
         else
         {
            list_of_links.reset();
         }
      }
   
   
      final void debug(String o) {
      
         System.out.println(o);
      }
   }
